/*
VODKA-INDUCED ENTERTAINMENT ADVANCED SOUND MANAGER v0.9.1
COMPATIBILITY LAYER FOR WOLF4SDL v1.6 - HEADER FILE
BY GERARD 'ALUMIUN' WATSON

MODIFIED BY WOLF 'WSJ' SKEVOS-JONES
*/

#ifndef _ASMCOMP_H_
#define _ASMCOMP_H_

#include "vieasm.h"

#define TickBase        70      // 70Hz per tick - used as a base for timer 0

#define GetTimeCount()  ((SDL_GetTicks()*TickBase)/1000)

inline void Delay(int wolfticks)
{
    if (wolfticks>0)
        SDL_Delay(wolfticks * 1000 / TickBase);
}

extern sample ASM_Audiosegs[NUMSOUNDS];
extern byte   SoundMode,MusicMode,soundvol,musicvol,reversestereo,curmusic;

typedef struct
{
    int32_t x,y;
    byte    flags;
    word    cursound;
} chanstruct;

extern chanstruct channelinfo[ASM_MAXCHANNELS];

#define SNDFL_LOOPED       1
#define SNDFL_CHECKDIST    2
#define SNDFL_CHECKDONE    4

#define UNCACHEAUDIOCHUNK(chunk)   ASM_Uncache(ASM_Audiosegs[chunk]);
#define SD_AbortIfMusOff           if (!MusicMode) return
#define SD_AbortIfSndOff           if (!SoundMode) return
#define SD_ChangeVolume(snd, mus)  ASM_ChangeVolume((byte)(snd * 1.28), (byte)(mus * 1.28))
#define SD_Reverse(reverse)        ASM_ReverseStereo(reverse)
#define SD_StopSound()             SD_StopChannel(-1)
#define SD_MusicPaused(song)       (SD_MusicPlaying(song) && Mix_PausedMusic())

// Functions

extern  void    SD_Startup(void),                                           // DONE
                SD_Shutdown(void);                                          // DONE

extern  int     SD_PlaySound(word sound, int channel, fixed x, fixed y, byte flags);
extern  int     SD_SoundPlaying(word sound, int channel);
extern  int     SD_ChannelPlaying(int channel);
extern  bool    SD_ChannelLooping(int channel);
extern  void    SD_UpdateSoundLoc(void);
extern  void    SD_StopChannel(int channel);
extern  void    SD_Resume(void);
extern  void    SD_ResumeSound(void);
extern  void    SD_Pause(void);
extern  void    SD_PauseSound(void);
extern  void    SD_LoadAllSounds(void);

extern  void    SD_StartMusic(int song);
extern  void    SD_StopMusic(void);
extern  int     SD_MusicPlaying(int song);
extern  void    SD_PauseMusic(void);
extern  void    SD_ResumeMusic(void);

extern  void    SD_SetSoundMode(byte mode);
extern  void    SD_SetMusicMode(byte mode);

#endif  // _ASMCOMP_H_
