// WL_ACT1.C

#include "wl_def.h"
#pragma hdrstop

/*
=============================================================================

                                                        STATICS

=============================================================================
*/


statobj_t       statobjlist[MAXSTATS];
statobj_t       *laststatobj;


struct statinfostruct
{
    short      picnum;
    wl_stat_t  type;
    uint32_t   specialFlags;    // they are ORed to the statobj_t flags
    byte       animframes;
} statinfo[] =
{
    {SPR_STAT_0},                           // puddle          spr1v
    {SPR_STAT_1,block},                     // Green Barrel    "
    {SPR_STAT_2,block},                     // Table/chairs    "
    {SPR_STAT_3,block,FL_FULLBRIGHT},       // Floor lamp      "
    {SPR_STAT_4,none,FL_FULLBRIGHT},        // Chandelier      "
    {SPR_STAT_5,block},                     // Hanged man      "
    {SPR_STAT_6,bo_alpo},                   // Bad food        "
    {SPR_STAT_7,block},                     // Red pillar      "
    //
    // NEW PAGE
    //
    {SPR_STAT_8,block},                     // Tree            spr2v
    {SPR_STAT_9},                           // Skeleton flat   "
    {SPR_STAT_10,block},                    // Sink            " (SOD:gibs)
    {SPR_STAT_11,block},                    // Potted plant    "
    {SPR_STAT_12,block},                    // Urn             "
    {SPR_STAT_13,block},                    // desk 1
    {SPR_STAT_14,none,FL_FULLBRIGHT},       // Ceiling light   "
    #ifndef SPEAR
    {SPR_STAT_15,none,FL_DIR_HORIZ_MID},    // Kitchen stuff   "
    #else
    {SPR_STAT_15,block},                    // Gibs!
    #endif
    //
    // NEW PAGE
    //
    {SPR_STAT_16,block},                    // suit of armor   spr3v
    {SPR_STAT_17,block},                    // Hanging cage    "
    {SPR_STAT_18,block},                    // SkeletoninCage  "
    {SPR_STAT_19},                          // Skeleton relax  "
    {SPR_STAT_20,bo_key1},                  // Key 1           "
    {SPR_STAT_21,bo_key2},                  // Key 2           "
    {SPR_STAT_22,block},                    // stuff             (SOD:gibs)
    {SPR_STAT_23,block},                    // desk 2
    //
    // NEW PAGE
    //
    {SPR_STAT_24,bo_food},                  // Good food       spr4v
    {SPR_STAT_25,bo_firstaid},              // First aid       "
    {SPR_STAT_26,bo_clip},                  // Clip            "
    {SPR_STAT_27,bo_mp40},                  // MP40            "
    {SPR_STAT_28,bo_mauser},                // Machine Pistol  "
    {SPR_STAT_29,bo_cross},                 // Cross           "
    {SPR_STAT_30,bo_chalice},               // Chalice         "
    {SPR_STAT_31,bo_bible},                 // Bible           "
    //
    // NEW PAGE
    //
    {SPR_STAT_32,bo_crown},                 // crown           spr5v
    {SPR_STAT_33,bo_fullheal,FL_FULLBRIGHT},// one up          "
    {SPR_STAT_34},                          // gibs            "
    {SPR_STAT_35,block},                    // barrel          "
    {SPR_STAT_36,block},                    // well            "
    {SPR_STAT_37,block},                    // Empty well      "
    {SPR_STAT_38},                          // Gibs 2          "
    {SPR_STAT_39,block},                    // flag            "
    //
    // NEW PAGE
    //
    #ifndef SPEAR
    {SPR_STAT_40,block},                    // Call Apogee          spr7v
    #else
    {SPR_STAT_40},                          // Red light
    #endif
    //
    // NEW PAGE
    //
    {SPR_STAT_41},                          // junk            "
    {SPR_STAT_42},                          // junk            "
    {SPR_STAT_43},                          // junk            "
    #ifndef SPEAR
    {SPR_STAT_44,none,FL_FULLBRIGHT},       // light bulb      "
    #else
    {SPR_STAT_44,block},                    // Gibs!
    #endif
    {SPR_STAT_45,block,FL_FULLBRIGHT,2},    // stove           " (SOD:gibs)
    {SPR_STAT_46,block},                    // spears          " (SOD:gibs)
    {SPR_STAT_47,none,FL_DIR_VERT_MID},     // vines           "
    //
    // NEW PAGE
    //
    #ifdef SPEAR
    {SPR_STAT_48,block},                    // marble pillar
    {SPR_STAT_49,bo_clip_big},              // large clip
    {SPR_STAT_50,block},                    // truck
    {SPR_STAT_51,bo_spear},                 // SPEAR OF DESTINY!
    #endif
    {SPR_STAT_47,none,FL_DIR_HORIZ_MID},    // vines
    {SPR_STAT2_0,bo_kar98k_sniper},         // Scoped Kar98k
    {SPR_STAT2_1,bo_stg44},                 // STG44
    {SPR_STAT2_2,bo_rounds},                // rifle rounds
    {SPR_STAT2_3,bo_rounds_big},            // box of rifle rounds
    {SPR_STAT2_4,bo_clip_big},              // large clip
    {SPR_STAT2_5,block},                    // operating table 1
    {SPR_STAT2_6,block},                    // operating table 2
    {SPR_STAT2_7,block},                    // operating table 3
    {SPR_STAT2_8,bo_key3},                  // Key 3
    {SPR_STAT2_9,bo_key4},                  // Key 4
    {SPR_STAT2_10,block},                   // toxic barrel
    {SPR_STAT2_11},                         // dead prisoner
    {SPR_STAT2_12},                         // brains
    {SPR_STAT2_13},                         // severed arm
    {SPR_STAT2_14},                         // gibs
    {SPR_STAT2_15},                         // gibs
    {SPR_STAT2_16,bo_pistol},               // Pistol
    {SPR_STAT2_17,block},                   // lab table 2
    {SPR_STAT2_18,bo_flamethrower},         // Flamethrower
    {SPR_STAT2_19,bo_fuel},                 // fuel canister
    {SPR_STAT2_20,bo_chaingun},             // Chaingun
    {SPR_STAT2_21,bo_ammobelt},             // ammo belt
    {SPR_STAT2_22,bo_panzerschreck},        // Panzerschreck
    {SPR_STAT2_23,bo_rocket},               // rocket
    {SPR_STAT2_24,bo_armor_small},          // helmet
    {SPR_STAT2_25,bo_armor_big},            // flak jacket
    {SPR_STAT2_26,bo_armor_uber},           // Uber-Armor
    {SPR_STAT2_27,bo_kar98k},               // Kar98k
    {SPR_STAT2_28,bo_mg42_mounted},         // Mounted MG42
    {SPR_STAT2_29,block,FL_DIR_VERT_MID},   // sandbags 1 (vertical)
    {SPR_STAT2_29,block,FL_DIR_HORIZ_MID},  // sandbags 1 (horizontal)
    {SPR_STAT2_30,block,FL_DIR_VERT_MID},   // sandbags 2 (vertical)
    {SPR_STAT2_30,block,FL_DIR_HORIZ_MID},  // sandbags 2 (horizontal)
    {SPR_STAT2_31_1,block,FL_DIR_VERT_MID}, // concrete window (vertical)
    {SPR_STAT2_31_2,block,FL_DIR_HORIZ_MID},// concrete window (horizontal)
    {SPR_STAT2_32,block},                   // charred skeleton
    {SPR_STAT2_40,block,FL_DIR_HORIZ_MID},  // truck back
    {SPR_STAT2_41,block,FL_DIR_HORIZ_MID},  // truck middle
    {SPR_STAT2_42,block,FL_DIR_HORIZ_MID},  // truck front
    {SPR_STAT2_43,bo_stg44ammo},            // STG44 ammo

    {SPR_STAT2_34,bo_mg42},                 // Portable MG42
    {-1}                                    // terminator
};

/*
===============
=
= InitStaticList
=
===============
*/

void InitStaticList (void)
{
    laststatobj = &statobjlist[0];
}



/*
===============
=
= SpawnStatic
=
===============
*/

void SpawnStatic (int tilex, int tiley, int type)
{
    SpawnSpecialStatic(tilex,tiley,(statinfo[type].type),(statinfo[type].picnum),(statinfo[type].specialFlags)
        ,(statinfo[type].animframes));
}

void SetItemFlags (statobj_t *statptr, uint32_t specialFlags)
{
    switch (statptr->itemnumber)
    {
        case bo_mg42_mounted:
        case block:
            actorat[statptr->tilex][statptr->tiley] = (objtype *) BLOCKTILE;
        case none:
            statptr->flags = 0;
            break;

        case bo_cross:
        case bo_chalice:
        case bo_bible:
        case bo_crown:
        case bo_fullheal:
            if (!loadedgame)
                gamestate.treasuretotal++;
        default:
            statptr->flags = FL_BONUS;
            break;
    }

    if (specialFlags)
        statptr->flags |= specialFlags;
}

void SpawnSpecialStatic (int tilex, int tiley, int type, short picnum, uint32_t specialFlags, byte animframes)
{
    laststatobj->shapenum = picnum;
    laststatobj->tilex = tilex;
    laststatobj->tiley = tiley;
    laststatobj->visspot = &spotvis[tilex][tiley];
    laststatobj->animframes = animframes;
    laststatobj->itemnumber = type;
    SetItemFlags(laststatobj,specialFlags);
    laststatobj++;

    if (laststatobj == &statobjlist[MAXSTATS])
        Quit ("Too many static objects!\n");
}


/*
===============
=
= PlaceItemType
=
= Called during game play to drop actors' items.  It finds the proper
= item number based on the item type (bo_???).  If there are no free item
= spots, nothing is done.
=
===============
*/

void PlaceItemType (int itemtype, int tilex, int tiley)
{
    int type;
    statobj_t *spot;

    //
    // find the item number
    //
    for (type=0; ; type++)
    {
        if (statinfo[type].picnum == -1)                    // end of list
            Quit ("PlaceItemType: couldn't find type!");
        if (statinfo[type].type == itemtype)
            break;
    }

    //
    // find a spot in statobjlist to put it in
    //
    for (spot=&statobjlist[0]; ; spot++)
    {
        if (spot==laststatobj)
        {
            if (spot == &statobjlist[MAXSTATS])
                return;                                     // no free spots
            laststatobj++;                                  // space at end
            break;
        }

        if (spot->shapenum == -1)                           // -1 is a free spot
            break;
    }
    //
    // place it
    //
    spot->shapenum = statinfo[type].picnum;
    spot->tilex = tilex;
    spot->tiley = tiley;
    spot->visspot = &spotvis[tilex][tiley];
    spot->animframes = statinfo[type].animframes;
    spot->itemnumber = statinfo[type].type;
    SetItemFlags(spot,statinfo[type].specialFlags);
    spot->flags |= FL_USED;
}



/*
=============================================================================

                                  DOORS

doorobjlist[] holds most of the information for the doors

doorposition[] holds the amount the door is open, ranging from 0 to 0xffff
        this is directly accessed by AsmRefresh during rendering

The number of doors is limited to 64 because a spot in tilemap holds the
        door number in the low 6 bits, with the high bit meaning a door center
        and bit 6 meaning a door side tile

Open doors conect two areas, so sounds will travel between them and sight
        will be checked when the player is in a connected area.

Areaconnect is incremented/decremented by each door. If >0 they connect

Every time a door opens or closes the areabyplayer matrix gets recalculated.
        An area is true if it connects with the player's current spor.

=============================================================================
*/

#define DOORWIDTH       0x7800
#define OPENTICS        300

doorobj_t       doorobjlist[MAXDOORS],*lastdoorobj;
short           doornum;

word            doorposition[MAXDOORS];             // leading edge of door 0=closed
                                                    // 0xffff = fully open

byte            areaconnect[NUMAREAS][NUMAREAS];

boolean         areabyplayer[NUMAREAS];


/*
==============
=
= ConnectAreas
=
= Scans outward from playerarea, marking all connected areas
=
==============
*/

void RecursiveConnect (int areanumber)
{
    int i;

    for (i=0;i<NUMAREAS;i++)
    {
        if (areaconnect[areanumber][i] && !areabyplayer[i])
        {
            areabyplayer[i] = true;
            RecursiveConnect (i);
        }
    }
}


void ConnectAreas (void)
{
    memset (areabyplayer,0,sizeof(areabyplayer));
    areabyplayer[player->areanumber] = true;
    RecursiveConnect (player->areanumber);
}


void InitAreas (void)
{
    memset (areabyplayer,0,sizeof(areabyplayer));
    if (player->areanumber < NUMAREAS)
        areabyplayer[player->areanumber] = true;
}


/*
==============
=
= AreaByArea
=
= WSJ: quick way of checking if two areas are connected
=
==============
*/

boolean AreaByArea (int area1, int area2)
{
    if (area1 >= NUMAREAS || area2 >= NUMAREAS || area1 < 0 || area2 < 0)
        return false;

    if (area1 == area2 || areaconnect[area1][area2] > 0 || areaconnect[area2][area1] > 0)
        return true;

    return false;
}


/*
===============
=
= InitDoorList
=
===============
*/

void InitDoorList (void)
{
    memset (areabyplayer,0,sizeof(areabyplayer));
    memset (areaconnect,0,sizeof(areaconnect));

    lastdoorobj = &doorobjlist[0];
    doornum = 0;
}


/*
===============
=
= SpawnDoor
=
===============
*/

void SpawnDoor (int tilex, int tiley, boolean vertical, int lock)
{
    word *map;

    if (doornum>=MAXDOORS)
        Quit ("Over %d doors on level!", MAXDOORS);

    doorposition[doornum] = 0;              // doors start out fully closed
    lastdoorobj->tilex = tilex;
    lastdoorobj->tiley = tiley;
    lastdoorobj->vertical = vertical;
    lastdoorobj->lock = lock;
    lastdoorobj->action = dr_closed;

    actorat[tilex][tiley] = (objtype *)(uintptr_t)(doornum | 0x80);   // consider it a solid wall

    //
    // make the door tile a special tile, and mark the adjacent tiles
    // for door sides
    //
    tilemap[tilex][tiley] = doornum | 0x80;
    map = mapsegs[0] + (tiley<<mapshift) +tilex;

    if (vertical)
    {
        if (VALIDAREATILE(*(map-1)))
            *map = *(map-1);
        else
            *map = *(map+1);
        tilemap[tilex][tiley-1] |= 0x40;
        tilemap[tilex][tiley+1] |= 0x40;
    }
    else
    {
        if (VALIDAREATILE(*(map-mapwidth)))
            *map = *(map-mapwidth);
        else
            *map = *(map+mapwidth);
        tilemap[tilex-1][tiley] |= 0x40;
        tilemap[tilex+1][tiley] |= 0x40;
    }

    doornum++;
    lastdoorobj++;
}

//===========================================================================

/*
=====================
=
= PlayDoorSound
=
= WSJ: play one door sound at a time
=
=====================
*/

void PlayDoorSound (int sound, int door)
{
    int tilex = doorobjlist[door].tilex;
    int tiley = doorobjlist[door].tiley;

    PlaySoundLocTile(sound,chan_door,tilex,tiley,SNDFL_CHECKDIST);
}


/*
=====================
=
= OpenDoor
=
=====================
*/

void OpenDoor (int door)
{
    if (doorobjlist[door].action == dr_open)
        doorobjlist[door].ticcount = 0;         // reset open time
    else
    {
        int area = *(mapsegs[0] + (doorobjlist[door].tiley<<mapshift)
            +doorobjlist[door].tilex)-AREATILE;
        if (doorobjlist[door].action == dr_closing && areabyplayer[area])
            PlayDoorSound(OPENDOORSND,door);    // WSJ: door was re-opened
        doorobjlist[door].action = dr_opening;  // start it opening
    }
}


/*
=====================
=
= CloseDoor
=
=====================
*/

void CloseDoor (int door)
{
    int     tilex,tiley,area;
    objtype *check;

    //
    // don't close on anything solid
    //
    tilex = doorobjlist[door].tilex;
    tiley = doorobjlist[door].tiley;

    if (actorat[tilex][tiley])
        return;

    if (player->tilex == tilex && player->tiley == tiley)
        return;

    if (doorobjlist[door].vertical)
    {
        if ( player->tiley == tiley )
        {
            if ( ((player->x+MINDIST) >>TILESHIFT) == tilex )
                return;
            if ( ((player->x-MINDIST) >>TILESHIFT) == tilex )
                return;
        }
        check = actorat[tilex-1][tiley];
        if (ISPOINTER(check) && ((check->x+MINDIST) >> TILESHIFT) == tilex )
            return;
        check = actorat[tilex+1][tiley];
        if (ISPOINTER(check) && ((check->x-MINDIST) >> TILESHIFT) == tilex )
            return;
    }
    else if (!doorobjlist[door].vertical)
    {
        if (player->tilex == tilex)
        {
            if ( ((player->y+MINDIST) >>TILESHIFT) == tiley )
                return;
            if ( ((player->y-MINDIST) >>TILESHIFT) == tiley )
                return;
        }
        check = actorat[tilex][tiley-1];
        if (ISPOINTER(check) && ((check->y+MINDIST) >> TILESHIFT) == tiley )
            return;
        check = actorat[tilex][tiley+1];
        if (ISPOINTER(check) && ((check->y-MINDIST) >> TILESHIFT) == tiley )
            return;
    }


    //
    // play door sound if in a connected area
    //
    area = *(mapsegs[0] + (doorobjlist[door].tiley<<mapshift)
        +doorobjlist[door].tilex)-AREATILE;
    if (areabyplayer[area])
    {
        PlayDoorSound(CLOSEDOORSND,door);
    }

    doorobjlist[door].action = dr_closing;
    //
    // make the door space solid
    //
    actorat[tilex][tiley] = (objtype *)(uintptr_t)(door | 0x80);
}


/*
=====================
=
= CheckLock
=
= WSJ: returns true if ob can open door
=
=====================
*/

boolean CheckLock (objtype *ob, int door)
{
    int lock,tilex,tiley;

    lock = doorobjlist[door].lock;
    tilex = doorobjlist[door].tilex;
    tiley = doorobjlist[door].tiley;

    switch (lock)
    {
        case dr_lock1:
        case dr_lock2:
        case dr_lock3:
        case dr_lock4:
            if ( !(gamestate.keys & (1<<(lock-dr_lock1))) )
                return false;
            break;
        case dr_lock_fw:
            if (ob->tilex < tilex || ob->tiley < tiley)
                return false;
            break;
        case dr_lock_bw:
            if (ob->tilex > tilex || ob->tiley > tiley)
                return false;
            break;
        case dr_toten:
            return false;
    }

    return true;
}


/*
=====================
=
= OperateDoor
=
= The player wants to change the door's direction
=
=====================
*/

void OperateDoor (int door)
{
    if (!CheckLock(player,door))
    {
        int lock = doorobjlist[door].lock;

        if (doorobjlist[door].action != dr_closed)
            return;

        // WSJ: tell the player why the door won't open
        switch (lock)
        {
            case dr_lock1:
            case dr_lock2:
            case dr_lock3:
            case dr_lock4:
                PlayDoorSound(NOWAYSND,door);
                sprintf(str,"You need the %s to open this door",keyname[lock-dr_lock1]);
                GetMessage(str);
                break;
            case dr_lock_fw:
            case dr_lock_bw:
                PlayDoorSound(NOWAYSND,door);
                GetMessage("This door is locked from the other side");
                break;
            case dr_toten:
                GetMessage("This door cannot be opened by normal means");
                break;
        }

        return;
    }

    switch (doorobjlist[door].action)
    {
        case dr_closed:
        case dr_closing:
            OpenDoor (door);
            break;
        case dr_open:
        case dr_opening:
            CloseDoor (door);
            break;
    }
}


//===========================================================================

/*
===============
=
= DoorOpen
=
= Close the door after three seconds
=
===============
*/

void DoorOpen (int door)
{
    int opentime;

    if (doorobjlist[door].lock == dr_toten)
        opentime = TOTENDELAYTICS;
    else
        opentime = OPENTICS;

    if ( (doorobjlist[door].ticcount += (short) tics) >= opentime)
        CloseDoor (door);
}



/*
===============
=
= DoorOpening
=
===============
*/

void DoorOpening (int door)
{
    unsigned area1,area2;
    word *map;
    int32_t position;

    position = doorposition[door];
    if (!position)
    {
        //
        // door is just starting to open, so connect the areas
        //
        map = mapsegs[0] + (doorobjlist[door].tiley<<mapshift)
            +doorobjlist[door].tilex;

        if (doorobjlist[door].vertical)
        {
            area1 = *(map+1);
            area2 = *(map-1);
        }
        else
        {
            area1 = *(map-mapwidth);
            area2 = *(map+mapwidth);
        }
        area1 -= AREATILE;
        area2 -= AREATILE;

        if (area1 < NUMAREAS && area2 < NUMAREAS)
        {
            areaconnect[area1][area2]++;
            areaconnect[area2][area1]++;

            if (player->areanumber < NUMAREAS)
                ConnectAreas ();

            if (areabyplayer[area1])
                PlayDoorSound(OPENDOORSND,door);
        }
    }

    //
    // slide the door by an adaptive amount
    //
    position += tics<<10;
    if (position >= 0xffff)
    {
        //
        // door is all the way open
        //
        position = 0xffff;
        doorobjlist[door].ticcount = 0;
        doorobjlist[door].action = dr_open;
        actorat[doorobjlist[door].tilex][doorobjlist[door].tiley] = 0;
    }

    doorposition[door] = (word) position;
}


/*
===============
=
= DoorClosing
=
===============
*/

void DoorClosing (int door)
{
    unsigned area1,area2;
    word *map;
    int32_t position;
    int tilex,tiley;

    tilex = doorobjlist[door].tilex;
    tiley = doorobjlist[door].tiley;

    if ( ((int)(uintptr_t)actorat[tilex][tiley] != (door | 0x80))
        || (player->tilex == tilex && player->tiley == tiley) )
    {                       // something got inside the door
        OpenDoor (door);
        return;
    };

    position = doorposition[door];

    //
    // slide the door by an adaptive amount
    //
    position -= tics<<10;
    if (position <= 0)
    {
        //
        // door is closed all the way, so disconnect the areas
        //
        position = 0;

        doorobjlist[door].action = dr_closed;

        map = mapsegs[0] + (doorobjlist[door].tiley<<mapshift) + doorobjlist[door].tilex;

        if (doorobjlist[door].vertical)
        {
            area1 = *(map+1);
            area2 = *(map-1);
        }
        else
        {
            area1 = *(map-mapwidth);
            area2 = *(map+mapwidth);
        }
        area1 -= AREATILE;
        area2 -= AREATILE;

        if (area1 < NUMAREAS && area2 < NUMAREAS)
        {
            areaconnect[area1][area2]--;
            areaconnect[area2][area1]--;

            if (player->areanumber < NUMAREAS)
                ConnectAreas ();
        }
    }

    doorposition[door] = (word) position;
}




/*
=====================
=
= MoveDoors
=
= Called from PlayLoop
=
=====================
*/

void MoveDoors (void)
{
    int door;

    if (gamestate.victoryflag)              // don't move door during victory sequence
        return;

    for (door = 0; door < doornum; door++)
    {
        switch (doorobjlist[door].action)
        {
            case dr_open:
                DoorOpen (door);
                break;

            case dr_opening:
                DoorOpening(door);
                break;

            case dr_closing:
                DoorClosing(door);
                break;
        }
    }
}


/*
=============================================================================

                                PUSHABLE WALLS

=============================================================================
*/

word pwallstate;
word pwallpos;                  // amount a pushable wall has been moved (0-63)
word pwallx,pwally;
byte pwalldir,pwalltile,pwalltex;
int dirs[4][2]={{0,-1},{1,0},{0,1},{-1,0}};

/*
===============
=
= PushWall
=
= WSJ: changed to boolean so that we'll know if it budged
=
===============
*/

boolean PushWall (int checkx, int checky, int dir)
{
    int  oldtile, oldtex, dx, dy;

    if (pwallstate)
        return false;

    oldtile = tilemap[checkx][checky];
    if (!oldtile || oldtile > 63)
        return false;

    oldtex = walltex[checkx][checky];

    dx = dirs[dir][0];
    dy = dirs[dir][1];

    if (actorat[checkx+dx][checky+dy])
        return false;

    actorat[checkx+dx][checky+dy] = (objtype *)(uintptr_t) (tilemap[checkx+dx][checky+dy] = oldtile);
    walltex[checkx+dx][checky+dy] = oldtex;

    pwallx = checkx;
    pwally = checky;
    pwalldir = dir;
    pwallstate = 1;
    pwallpos = 0;
    pwalltile = tilemap[pwallx][pwally];
    pwalltex = walltex[pwallx][pwally];
    tilemap[pwallx][pwally] = 64;
    tilemap[pwallx+dx][pwally+dy] = 64;
    walltex[pwallx][pwally] = 0;

    PlaySoundLocTile(PUSHWALLSND,chan_pushwall,pwallx,pwally,0);

    return true;
}



/*
=================
=
= MovePWalls
=
=================
*/

void MovePWalls (void)
{
    int oldblock,oldtile,oldtex;

    if (!pwallstate)
        return;

    oldblock = pwallstate/128;

    pwallstate += (word)tics;

    if (pwallstate/128 != oldblock)
    {
        // block crossed into a new block
        oldtile = pwalltile;
        oldtex = pwalltex;

        //
        // the tile can now be walked into
        //
        tilemap[pwallx][pwally] = 0;
        walltex[pwallx][pwally] = 0;
        actorat[pwallx][pwally] = 0;

        int dx=dirs[pwalldir][0], dy=dirs[pwalldir][1];
        //
        // see if it should be pushed farther
        //
        if (pwallstate>=256)            // only move two tiles fix
        {
            //
            // the block has been pushed two tiles
            //
            pwallstate = 0;
            tilemap[pwallx+dx][pwally+dy] = oldtile;
            walltex[pwallx+dx][pwally+dy] = oldtex;
            return;
        }
        else
        {
            int xl,yl,xh,yh;
            xl = (player->x-PLAYERSIZE) >> TILESHIFT;
            yl = (player->y-PLAYERSIZE) >> TILESHIFT;
            xh = (player->x+PLAYERSIZE) >> TILESHIFT;
            yh = (player->y+PLAYERSIZE) >> TILESHIFT;

            pwallx += dx;
            pwally += dy;

            if (actorat[pwallx+dx][pwally+dy]
                || xl<=pwallx+dx && pwallx+dx<=xh && yl<=pwally+dy && pwally+dy<=yh)
            {
                pwallstate = 0;
                tilemap[pwallx][pwally] = oldtile;
                walltex[pwallx][pwally] = oldtex;
                return;
            }
            actorat[pwallx+dx][pwally+dy] = (objtype *)(uintptr_t) (tilemap[pwallx+dx][pwally+dy] = oldtile);
            tilemap[pwallx+dx][pwally+dy] = 64;
            walltex[pwallx+dx][pwally+dy] = 0;
            PlaySoundLocTile(PUSHWALLSND,chan_pushwall,pwallx,pwally,0);
        }
    }

    pwallpos = (pwallstate/2)&63;
}
