// WL_ACT2.C

#include <stdio.h>
#include <math.h>
#include "wl_def.h"
#pragma hdrstop

/*
=============================================================================

                               LOCAL CONSTANTS

=============================================================================
*/

#define PROJECTILESIZE  0xc000l
#define PLAYERPROJSIZE  0x18000l

#define BJRUNSPEED      2048
#define BJJUMPSPEED     680


/*
=============================================================================

                              GLOBAL VARIABLES

=============================================================================
*/



/*
=============================================================================

                              LOCAL VARIABLES

=============================================================================
*/


dirtype dirtable[9] = {northwest,north,northeast,west,nodir,east,
    southwest,south,southeast};

short starthitpoints[4][NUMOBCLASSES] =
{
    //
    // BABY MODE
    //
    {
        0,    // nothing
        0,    // playerobj
        0,    // inertobj
        25,   // guardobj
        25,   // riflemanobj
        25,   // infantryobj
        25,   // officerobj
        25,   // officer2obj
        25,   // mg42guardobj
        75,   // ssobj
        75,   // ssriflemanobj
        75,   // ssofficerobj
        75,   // ssofficer2obj
        75,   // mg42ssobj
        75,   // sniperobj
        1,    // dogobj
        15,   // scientistobj
        150,  // waffenssobj
        150,  // waffenofficerobj
        150,  // mg42waffenssobj
        100,  // mutantobj
        200,  // mechtrooperobj
        200,  // flametrooperobj
        200,  // chaingunnerobj
        200,  // rockettrooperobj
        850,  // bossobj
        850,  // schabbobj
        1450, // fatobj
        2000, // panzobj
        850,  // deatharmorobj
    },
    //
    // DON'T HURT ME MODE
    //
    {
        0,    // nothing
        0,    // playerobj
        0,    // inertobj
        35,   // guardobj
        35,   // riflemanobj
        35,   // infantryobj
        35,   // officerobj
        35,   // officer2obj
        35,   // mg42guardobj
        100,  // ssobj
        100,  // ssriflemanobj
        100,  // ssofficerobj
        100,  // ssofficer2obj
        100,  // mg42ssobj
        100,  // sniperobj
        1,    // dogobj
        25,   // scientistobj
        175,  // waffenssobj
        175,  // waffenofficerobj
        175,  // mg42waffenssobj
        125,  // mutantobj
        300,  // mechtrooperobj
        300,  // flametrooperobj
        300,  // chaingunnerobj
        300,  // rockettrooperobj
        950,  // bossobj
        950,  // schabbobj
        1550, // fatobj
        3000, // panzobj
        950,  // deatharmorobj
    },
    //
    // BRING 'EM ON MODE
    //
    {
        0,    // nothing
        0,    // playerobj
        0,    // inertobj
        50,   // guardobj
        50,   // riflemanobj
        50,   // infantryobj
        50,   // officerobj
        50,   // officer2obj
        50,   // mg42guardobj
        125,  // ssobj
        125,  // ssriflemanobj
        125,  // ssofficerobj
        125,  // ssofficer2obj
        125,  // mg42ssobj
        125,  // sniperobj
        1,    // dogobj
        40,   // scientistobj
        200,  // waffenssobj
        200,  // waffenofficerobj
        200,  // mg42waffenssobj
        150,  // mutantobj
        400,  // mechtrooperobj
        400,  // flametrooperobj
        400,  // chaingunnerobj
        400,  // rockettrooperobj
        1050, // bossobj
        1550, // schabbobj
        1650, // fatobj
        4000, // panzobj
        1050, // deatharmorobj
    },
    //
    // DEATH INCARNATE MODE
    //
    {
        0,    // nothing
        0,    // playerobj
        0,    // inertobj
        75,   // guardobj
        75,   // riflemanobj
        75,   // infantryobj
        75,   // officerobj
        75,   // officer2obj
        75,   // mg42guardobj
        150,  // ssobj
        150,  // ssriflemanobj
        150,  // ssofficerobj
        150,  // ssofficer2obj
        150,  // mg42ssobj
        150,  // sniperobj
        1,    // dogobj
        55,   // scientistobj
        250,  // waffenssobj
        250,  // waffenofficerobj
        250,  // mg42waffenssobj
        175,  // mutantobj
        500,  // mechtrooperobj
        500,  // flametrooperobj
        500,  // chaingunnerobj
        500,  // rockettrooperobj
        1200, // bossobj
        2400, // schabbobj
        2000, // fatobj
        5000, // panzobj
        1200, // deatharmorobj
    }
};

void    A_StartDeathCam (objtype *ob);


void    T_Path (objtype *ob);
void    T_Aim (objtype *ob);
void    T_Aim2 (objtype *ob);
void    T_Shoot (objtype *ob);
void    T_Bite (objtype *ob);
void    T_DogChase (objtype *ob);
void    T_Chase (objtype *ob);
void    T_Projectile (objtype *ob);
void    T_Stand (objtype *ob);
void    T_Sniper (objtype *ob);

void A_DeathScream (objtype *ob);
void Refire (objtype *ob, short maxrepeat, statetype *state, void (*Action)(objtype *));
void SplashDamage (objtype *ob, short maxdamage, damage_t damagetype, short blastradius, boolean hurtenemies);

extern  statetype s_rocket;
extern  statetype s_seeker;
extern  statetype s_smoke1;
extern  statetype s_smoke2;
extern  statetype s_smoke3;
extern  statetype s_smoke4;
extern  statetype s_boom2;
extern  statetype s_boom3;
extern  statetype s_boom4;

void T_Seeker (objtype *ob)         { T_Aim2(ob); T_Projectile(ob); }
void A_Smoke (objtype *ob)          { SpawnBulletPuff(ob->x,ob->y,&s_smoke1,ob->sproffset); }
void A_RocketBlast (objtype *ob)    { SplashDamage(ob,200,dam_rocket,6,false); }
void A_BJRocketBlast (objtype *ob)  { SplashDamage(ob,400,dam_rocket,6,true); }

statetype s_rocket              = {2,SPR_ROCKET_1,1,(statefunc)T_Projectile,(statefunc)A_Smoke,&s_rocket,true};
statetype s_seeker              = {2,SPR_ROCKET_1,1,(statefunc)T_Seeker,(statefunc)A_Smoke,&s_seeker,true};
statetype s_smoke1              = {false,SPR_SMOKE_1,12,NULL,NULL,&s_smoke2};
statetype s_smoke2              = {false,SPR_SMOKE_2,6,NULL,NULL,&s_smoke3};
statetype s_smoke3              = {false,SPR_SMOKE_3,6,NULL,NULL,&s_smoke4};
statetype s_smoke4              = {false,SPR_SMOKE_4,6,NULL,NULL,NULL};

statetype s_boom1               = {false,SPR_BOOM_1,1,NULL,(statefunc)A_RocketBlast,&s_boom2,true};
statetype s_boom1bj             = {false,SPR_BOOM_1,1,NULL,(statefunc)A_BJRocketBlast,&s_boom2,true};
statetype s_flakboom1           = {false,SPR_BOOM_1,1,NULL,NULL,&s_boom2,true};
statetype s_boom2               = {false,SPR_BOOM_1,6,NULL,NULL,&s_boom3,true};
statetype s_boom3               = {false,SPR_BOOM_2,6,NULL,NULL,&s_boom4,true};
statetype s_boom4               = {false,SPR_BOOM_3,6,NULL,NULL,NULL,true};

extern  statetype s_erocket1;
extern  statetype s_esmoke1;
extern  statetype s_esmoke2;
extern  statetype s_esmoke3;
extern  statetype s_esmoke4;

void A_ESmoke (objtype *ob)     { SpawnBulletPuff(ob->x,ob->y,&s_esmoke1,ob->sproffset); }

statetype s_erocket1            = {2,SPR_ROCKET_1,1,(statefunc)T_Seeker,(statefunc)A_ESmoke,&s_erocket1,true};
statetype s_esmoke1             = {false,SPR_SMOKE_1,12,NULL,NULL,&s_esmoke2,true};
statetype s_esmoke2             = {false,SPR_SMOKE_2,6,NULL,NULL,&s_esmoke3,true};
statetype s_esmoke3             = {false,SPR_SMOKE_3,6,NULL,NULL,&s_esmoke4,true};
statetype s_esmoke4             = {false,SPR_SMOKE_4,6,NULL,NULL,NULL,true};


extern  statetype s_fire1;
extern  statetype s_fire2;
extern  statetype s_fire3;
extern  statetype s_fire4;
extern  statetype s_fire5;
extern  statetype s_fire6;
extern  statetype s_fire7;
extern  statetype s_fire8;
extern  statetype s_firehit1;
extern  statetype s_firehit2;
extern  statetype s_firehit3;

statetype s_fire1               = {false,SPR_FIRE1,6,(statefunc)T_Projectile,NULL,&s_fire2,true};
statetype s_fire2               = {false,SPR_FIRE2,6,(statefunc)T_Projectile,NULL,&s_fire3,true};
statetype s_fire3               = {false,SPR_FIRE1,6,(statefunc)T_Projectile,NULL,&s_fire4,true};
statetype s_fire4               = {false,SPR_FIRE2,6,(statefunc)T_Projectile,NULL,&s_fire5,true};
statetype s_fire5               = {false,SPR_FIRE3,6,(statefunc)T_Projectile,NULL,&s_fire6,true};
statetype s_fire6               = {false,SPR_FIRE4,6,(statefunc)T_Projectile,NULL,&s_fire7,true};
statetype s_fire7               = {false,SPR_FIRE3,6,(statefunc)T_Projectile,NULL,&s_fire8,true};
statetype s_fire8               = {false,SPR_FIRE4,6,(statefunc)T_Projectile,NULL,&s_firehit1,true};

statetype s_firehit1            = {false,SPR_FIREHIT1,4,NULL,NULL,&s_firehit2,true};
statetype s_firehit2            = {false,SPR_FIREHIT2,4,NULL,NULL,&s_firehit3,true};
statetype s_firehit3            = {false,SPR_FIREHIT3,4,NULL,NULL,NULL,true};


void    T_Schabb (objtype *ob);
void    T_SchabbThrow (objtype *ob);
void    T_Ghosts (objtype *ob);

void A_Slurpie (objtype *ob);
void A_HitlerMorph (objtype *ob);


/*
===================
=
= ProjectileTryMove
=
= returns true if move ok
===================
*/

#define PROJSIZE        0x2000

boolean ProjectileTryMove (objtype *ob)
{
    int      xl,yl,xh,yh,x,y;
    objtype *check;

    xl = (ob->x-PROJSIZE) >> TILESHIFT;
    yl = (ob->y-PROJSIZE) >> TILESHIFT;

    xh = (ob->x+PROJSIZE) >> TILESHIFT;
    yh = (ob->y+PROJSIZE) >> TILESHIFT;

    //
    // check for solid walls
    //
    for (y=yl;y<=yh;y++)
        for (x=xl;x<=xh;x++)
        {
            check = actorat[x][y];
            if (check && !ISPOINTER(check) && tilemap[x][y])
            {
                //if (walltex[x][y] == LANDSCAPETILE)
                //{
                //    ob->state = NULL;    // WSJ: projectile flew off into the distance...
                //    return true;
                //}
                return false;
            }
        }

        return true;
}



/*
=================
=
= T_Projectile
=
=================
*/

void ProjectileHit (objtype *ob, objtype *target)
{
    int     damage = 0;

    damage_t damagetype = dam_bullet;

    switch (ob->obclass)
    {
        case needleobj:
            damage = (US_RndT() >>3);
            damagetype = dam_mutagen;
            ob->state = NULL;               // mark for removal
            break;
        case rocketobj:
            damagetype = dam_rocket;
            PlaySoundLocActor(MISSILEHITSND,chan_explosion,ob,0);
            ob->state = &s_boom1;
            break;
        case bjrocketobj:
            damagetype = dam_rocket;
            PlaySoundLocActor(MISSILEHITSND,chan_explosion,ob,0);
            ob->state = &s_boom1bj;
            break;
        case sparkobj:
            damage = (US_RndT() >>5);
            damagetype = dam_chaingun;
            ob->state = NULL;               // mark for removal
            if (!target)
                SpawnRicochet (ob->x,ob->y,ob->sproffset,damagetype);
            break;
        case fireobj:
            damage = (US_RndT() >>4);
            damagetype = dam_fire;
            ob->state = &s_firehit1;
            break;
        case bjfireobj:
            damage = (US_RndT() >>3);
            damagetype = dam_fire;
            ob->state = &s_firehit1;
            break;
        default:
            ob->state = NULL;               // mark for removal
    }

    if (!target || !damage)
        return;

    if (target == player)
        TakeDamage (damage,ob,damagetype,false,true);
    else
        DamageActor (target,ob,damage,damagetype);
}

void T_Projectile (objtype *ob)
{
    int32_t deltax,deltay;
    int32_t speed;

    speed = (int32_t)ob->speed*tics;

    deltax = FixedMul(speed,costable[ob->angle]);
    deltay = -FixedMul(speed,sintable[ob->angle]);

    if (deltax>0x10000l)
        deltax = 0x10000l;
    if (deltay>0x10000l)
        deltay = 0x10000l;

    ob->x += deltax;
    ob->y += deltay;

    deltax = LABS(ob->x - player->x);
    deltay = LABS(ob->y - player->y);

    if (!ProjectileTryMove (ob))
    {
        ProjectileHit (ob,NULL);
        return;
    }

    if (ob->obclass == bjrocketobj || ob->obclass == bjfireobj)
    {
        objtype *check;

        for (check = player->next; check; check = check->next)
        {
            if (!(check->flags & FL_SHOOTABLE))
                continue;

            deltax = LABS(ob->x - check->x);
            deltay = LABS(ob->y - check->y);

            if (deltax < PLAYERPROJSIZE && deltay < PLAYERPROJSIZE)
            {
                ProjectileHit (ob,check);
                return;
            }
        }
    }
    else if (deltax < PROJECTILESIZE && deltay < PROJECTILESIZE)
    {       // hit the player
        ProjectileHit (ob,player);
        return;
    }

    ob->tilex = (short)(ob->x >> TILESHIFT);
    ob->tiley = (short)(ob->y >> TILESHIFT);
}


/*
=================
=
= SplashDamage
=
= WSJ: based on Matthew's explosion code
=
=================
*/

void SplashDamage (objtype *ob, short maxdamage, damage_t damagetype, short blastradius, boolean hurtenemies)
{
    objtype *check;
    int32_t dist;
    int damage;

    dist = (int32_t)sqrt(pow(player->x-ob->x,2)+pow(player->y-ob->y,2));
    if (dist < TILEGLOBAL*blastradius)
    {
        if (CheckLine(ob))
        {
            damage = (int)((double)maxdamage / pow(((double)dist / (double)TILEGLOBAL),2));
            if (damage > (maxdamage/4))
                damage = (maxdamage/4);
            TakeDamage(damage,ob,damagetype,false,true);
        }
    }

    if (!hurtenemies)
        return;

    for (check = player->next; check; check = check->next)
    {
        if (check->flags & FL_SHOOTABLE)
        {
            dist = (int32_t)sqrt(pow(check->x-ob->x,2)+pow(check->y-ob->y,2));
            if (dist < TILEGLOBAL*blastradius)
            {
                if (CheckObjLine(ob,check))
                {
                    damage = (int)((double)maxdamage / pow(((double)dist / (double)TILEGLOBAL),2));
                    if (damage > maxdamage)
                    damage = maxdamage;
                    DamageActor(check,ob,damage,damagetype);
                }
            }
        }
    }
}


//
// bullet effects
//
extern  statetype s_tracer1;
extern  statetype s_tracer2;
extern  statetype s_etracer1;
extern  statetype s_etracer2;
extern  statetype s_etracer3;
extern  statetype s_ricochet1;
extern  statetype s_ricochet2;
extern  statetype s_ricochet3;
extern  statetype s_ricochet4;
extern  statetype s_bloodsplat1;
extern  statetype s_bloodsplat2;
extern  statetype s_bloodsplat3;
extern  statetype s_bloodsplat4;

statetype s_tracer1             = {2,SPR_TRACER_1,1,NULL,NULL,&s_tracer2};
statetype s_tracer2             = {2,SPR_TRACER_1,1,NULL,NULL,NULL};

statetype s_etracer1            = {2,SPR_TRACER_1,3,(statefunc)T_Projectile,NULL,&s_etracer2,true};
statetype s_etracer2            = {2,SPR_TRACER_1,20,(statefunc)T_Projectile,NULL,&s_etracer3,true};
statetype s_etracer3            = {2,SPR_TRACER_1,3,(statefunc)T_Seeker,NULL,&s_etracer3,true};

statetype s_ricochet1           = {false,SPR_RICOCHET_1,4,NULL,NULL,&s_ricochet2,true};
statetype s_ricochet2           = {false,SPR_RICOCHET_2,4,NULL,NULL,&s_ricochet3,true};
statetype s_ricochet3           = {false,SPR_RICOCHET_3,4,NULL,NULL,&s_ricochet4,true};
statetype s_ricochet4           = {false,SPR_RICOCHET_4,4,NULL,NULL,NULL,true};

statetype s_bloodsplat1         = {false,SPR_RBLOOD_1,4,NULL,NULL,&s_bloodsplat2};
statetype s_bloodsplat2         = {false,SPR_RBLOOD_2,4,NULL,NULL,&s_bloodsplat3};
statetype s_bloodsplat3         = {false,SPR_RBLOOD_3,4,NULL,NULL,&s_bloodsplat4};
statetype s_bloodsplat4         = {false,SPR_RBLOOD_4,4,NULL,NULL,NULL};


/*
=================
=
= SpawnTracer
=
=================
*/

void SpawnTracer (fixed tracerx, fixed tracery, short angle, short spriteoffset)
{
    GetNewActor ();
    newobj->state = &s_tracer1;
    newobj->sproffset = spriteoffset;
    newobj->ticcount = 1;
    newobj->x = tracerx;
    newobj->y = tracery;
    newobj->angle = angle;
    newobj->tilex = (short)(tracerx >> TILESHIFT);
    newobj->tiley = (short)(tracery >> TILESHIFT);
    newobj->obclass = tracerobj;
    newobj->active = ac_yes;
    newobj->flags = FL_NEVERMARK;
}


/*
=================
=
= SpawnBulletPuff
=
=================
*/

void SpawnBulletPuff (fixed puffx, fixed puffy, statetype *state, short spriteoffset)
{
    GetNewActor ();
    newobj->state = state;
    newobj->sproffset = spriteoffset;
    newobj->ticcount = 1;
    newobj->x = puffx;
    newobj->y = puffy;
    newobj->tilex = (short)(puffx >> TILESHIFT);
    newobj->tiley = (short)(puffy >> TILESHIFT);
    newobj->obclass = inertobj;
    newobj->active = ac_yes;
    newobj->flags = FL_NEVERMARK;
}

void SpawnRicochet (fixed puffx, fixed puffy, short spriteoffset, damage_t damagetype)
{
    SD_PlaySound(RICOCHET1SND+Random(3),chan_ricochet,puffx,puffy,0);
    SpawnBulletPuff(puffx,puffy,&s_ricochet1,spriteoffset);
}

void SpawnFlakPuff (objtype *ob, fixed puffx, fixed puffy, short damage, short spriteoffset)
{
    int expsounds[4]={EXPLOSION1SND,EXPLOSION2SND,EXPLOSION3SND};
    SD_PlaySound(expsounds[Random(3)],chan_ricochet,puffx,puffy,0);
    SpawnBulletPuff(puffx,puffy,&s_flakboom1,spriteoffset);
    SplashDamage(newobj,damage,dam_flak,3,(ob == player));
}

void SpawnBloodPuff (objtype *ob, fixed puffx, fixed puffy)
{
    switch (ob->obclass)
    {
        case playerobj:
             break;
        case mechtrooperobj:
             if (ob->hitpoints&1)
             {
                 SpawnBulletPuff(ob->x,ob->y,&s_ricochet1,(SPR_HSPARK_1-SPR_RICOCHET_1));
                 break;
             }
        case mutantobj:
        case schabbobj:
        case deatharmorobj:
             SpawnBulletPuff (puffx,puffy,&s_bloodsplat1,(SPR_PBLOOD_1-SPR_RBLOOD_1));
             break;
        default:
             SpawnBulletPuff (puffx,puffy,&s_bloodsplat1,0);
             break;
    }
}


/*
=============================================================================

ACTOR SOUND STUFF

=============================================================================
*/

/*
=================
=
= PlayActorSound
=
=================
*/

void PlayActorVoice (int sound, int channel, objtype *ob)
{
    if (!areabyplayer[ob->areanumber] && !(ob->flags&FL_VISABLE))
        return;

    PlaySoundLocActor(sound,channel,ob,0);
}

void PlayActorWeapon (int sound, objtype *ob)
{
    PlaySoundLocActor(sound,chan_weapon_actor,ob,0);
    MakeNoise(ob);
}

void PlayBossVoice (int sound)
{
    PlaySoundGlobal(sound,chan_voice_boss,0);
}


/*
==================
=
= A_AlertSound
=
==================
*/

void A_AlertSound (objtype *ob)
{
    switch (ob->obclass)
    {
        case guardobj:
        case riflemanobj:
        case infantryobj:
        case officerobj:
        case officer2obj:
        case scientistobj:
        case ssobj:
        case ssriflemanobj:
        case ssofficerobj:
        case ssofficer2obj:
        case waffenssobj:
        case waffenofficerobj:
            if (ob->alert == alert_sight)
            {
                int sounds[8]={ GRDSIGHT1SND,
                    GRDSIGHT2SND,
                    GRDSIGHT3SND,
                    GRDSIGHT4SND,
                    GRDSIGHT5SND,
                    GRDSIGHT6SND,
                    GRDSIGHT7SND
                };
                PlayActorVoice(sounds[Random(7)],chan_voice_guard,ob);
            }
            else if (ob->alert == alert_hear)
            {
                int sounds[6]={ GRDHEAR1SND,
                    GRDHEAR2SND,
                    GRDHEAR3SND,
                    GRDHEAR4SND,
                    GRDHEAR5SND
                };
                PlayActorVoice(sounds[Random(5)],chan_voice_guard,ob);
            }
            else if (ob->alert == alert_findbody)
            {
                int sounds[4]={ GRDFINDBODY1SND,
                    GRDFINDBODY2SND,
                    GRDFINDBODY3SND
                };
                PlayActorVoice(sounds[Random(3)],chan_voice_guard,ob);
            }
            break;
        case mg42guardobj:
        case mg42ssobj:
        case mg42waffenssobj:
            PlayActorWeapon(USEMG42SND,ob);
            break;
        case dogobj:
            {
                int sounds[5]={ DOGBARK1SND,
                    DOGBARK2SND,
                    DOGBARK3SND,
                    DOGBARK4SND
                };
                PlayActorVoice(sounds[Random(4)],chan_voice_dog,ob);
            }
            break;
        case bossobj:
            PlayBossVoice(BOSS1SIGHTSND);
            GetSubtitle ("Guten Morgen!");
            break;
        case schabbobj:
            PlayBossVoice(BOSS2SIGHTSND);
            break;
        case deatharmorobj:
            PlayBossVoice(ROAR1SND);
            break;
        case fatobj:
            PlayBossVoice(BOSS3SIGHTSND);
            GetSubtitle ("I have ways of making you die.");
            break;
        case panzobj:
            PlayBossVoice(BOSS4SIGHTSND);
            GetSubtitle ("No escape for you!");
            break;
    }
}


/*
==================
=
= ChatterSound
=
= WSJ: enemy makes noise while going after player
=
==================
*/

void ChatterSound (objtype *ob, short tics)
{
    typedef struct {
        int sound;
        char subtitle[100];
    } bossquotetype;

    bossquotetype boss1taunts[11] = {
        {BOSS1TAUNT1SND},
        {BOSS1TAUNT2SND},
        {BOSS1TAUNT3SND,"That makes me angry!"},
        {BOSS1TAUNT4SND,"I will crush you like an insect!"},
        {BOSS1TAUNT1SND},
        {BOSS1TAUNT5SND,"Die, you American Schwein!"},
        {BOSS1TAUNT6SND,"You fight like a girl!"},
        {BOSS1TAUNT2SND},
        {BOSS1TAUNT7SND,"Eat bullets!"},
        {BOSS1TAUNT8SND,"The Fuhrer will be pleased!"},
    };

    bossquotetype boss3taunts[10] = {
        {BOSS3TAUNT1SND},
        {BOSS3TAUNT2SND},
        {BOSS3TAUNT3SND,"I've been looking forward to this."},
        {BOSS3TAUNT4SND,"You will BEG for death before I'm done with you."},
        {BOSS3TAUNT1SND},
        {BOSS3TAUNT5SND,"I eat spies like you for breakfast."},
        {BOSS3TAUNT6SND,"You Americans are all the same."},
        {BOSS3TAUNT2SND},
        {BOSS3TAUNT7SND,"For you, the war is over... PERMANENTLY."},
    };

    bossquotetype boss4taunts[10] = {
        {BOSS4TAUNT1SND,"Where's your Uncle Sam NOW?"},
        {BOSS4TAUNT2SND,"This is for my brother!"},
        {BOSS4TAUNT3SND,"This is for my sister!"},
        {BOSS4TAUNT4SND,"I hope you picked out a farm."},
        {BOSS4TAUNT5SND},
        {BOSS4TAUNT6SND,"I am INVINCIBLE!"},
        {BOSS4TAUNT7SND},
        {BOSS4TAUNT8SND,"Some 'One-Man Army' you turned out to be!"},
        {BOSS4TAUNT9SND,"Can we hurry up? I'm getting hungry."},
    };

    if (!ob->areanumber || !(ob->flags & FL_ATTACKMODE))
        return;

    ob->ambientcount += tics;

    switch (ob->obclass)
    {
        case dogobj:
            if (ob->ambientcount >= 160)
            {
                int sounds[5]={ DOGBARK1SND,
                    DOGBARK2SND,
                    DOGBARK3SND,
                    DOGBARK4SND
                };
                ob->ambientcount = 0;
                PlayActorVoice(sounds[Random(4)],chan_voice_dog,ob);
            }
            break;
        case bossobj:
            if (ob->ambientcount >= 700)
            {
                ob->ambientcount = 0;
                if (ob->temp2 < 10)
                {
                    PlayBossVoice(boss1taunts[ob->temp2].sound);
                    GetSubtitle(boss1taunts[ob->temp2].subtitle);
                    ob->temp2++;
                }
            }
            break;
        case schabbobj:
            if (ob->ambientcount >= 700)
            {
                ob->ambientcount = 0;
                PlayBossVoice(BOSS2SIGHTSND);
            }
            break;
        case fatobj:
            if (ob->ambientcount >= 700)
            {
                ob->ambientcount = 0;
                if (ob->temp2 < 9)
                {
                    PlayBossVoice(boss3taunts[ob->temp2].sound);
                    GetSubtitle(boss3taunts[ob->temp2].subtitle);
                    ob->temp2++;
                }
            }
            break;
        case panzobj:
            if (ob->ambientcount >= 700)
            {
                ob->ambientcount = 0;
                if (ob->temp2 < 9)
                {
                    PlayBossVoice(boss4taunts[ob->temp2].sound);
                    GetSubtitle(boss4taunts[ob->temp2].subtitle);
                    ob->temp2++;
                }
            }
            break;
        case deatharmorobj:
            if (ob->ambientcount >= 560)
            {
                int sounds[3]={GROWL1SND,GROWL2SND};
                ob->ambientcount = 0;
                PlayBossVoice(sounds[Random(2)]);
            }
            break;
    }

    if (ob->ambientcount > 4200)
        ob->ambientcount = 0;    // WSJ: don't let timer go over 1 minute
}


/*
==================
=
= GuardChatterSound
=
= WSJ: the soldiers' "battle chatter" is handled a bit
= differently from other chatter sounds: they only talk
= at certain intervals, and only one can talk at a time
=
==================
*/

#define GUARDAMBIENTCOUNT 350

boolean GuardChatterSound (objtype *ob)
{
    int guardsearchsounds[7]={
        GRDSEARCH1SND,
        GRDSEARCH2SND,
        GRDSEARCH3SND,
        GRDSEARCH4SND,
        GRDSEARCH5SND,
        GRDSEARCH6SND};

    int guardcombatsounds[7]={
        GRDCOMBAT1SND,
        GRDCOMBAT2SND,
        GRDCOMBAT3SND,
        GRDCOMBAT4SND,
        GRDCOMBAT5SND,
        GRDCOMBAT6SND};

    int officersearchsounds[7]={
        OFCSEARCH1SND,
        OFCSEARCH2SND,
        OFCSEARCH3SND,
        OFCSEARCH4SND,
        OFCSEARCH5SND,
        OFCSEARCH6SND};

    if (!ob->areanumber || !areabyplayer[ob->areanumber])
        return false;

    if (!(ob->flags & FL_ATTACKMODE) || (ob->flags&FL_AMBUSH))
        return false;

    if (ob->ambientcount < GUARDAMBIENTCOUNT)
        return false;

    switch (ob->obclass)
    {
        case guardobj:
        case riflemanobj:
        case infantryobj:
        case ssobj:
        case ssriflemanobj:
        case waffenssobj:
            ob->ambientcount = GUARDAMBIENTCOUNT;
            if (CheckLine(ob))
                PlayActorVoice(guardcombatsounds[Random(6)],chan_voice_guard,ob);
            else
                PlayActorVoice(guardsearchsounds[Random(6)],chan_voice_guard,ob);
            return true;
        case officerobj:
        case officer2obj:
        case ssofficerobj:
        case ssofficer2obj:
        case waffenofficerobj:
            ob->ambientcount = GUARDAMBIENTCOUNT;
            if (CheckLine(ob))
                PlayActorVoice(guardcombatsounds[Random(6)],chan_voice_guard,ob);
            else
                PlayActorVoice(officersearchsounds[Random(6)],chan_voice_guard,ob);
            return true;
        case scientistobj:
            ob->ambientcount = GUARDAMBIENTCOUNT;
            PlayActorVoice(officersearchsounds[Random(6)],chan_voice_guard,ob);
            return true;
    }
    return false;
}


/*
==================
=
= A_DeathScream
=
==================
*/

void A_DeathScream (objtype *ob)
{
    switch (ob->obclass)
    {
        case guardobj:
        case riflemanobj:
        case infantryobj:
        case officerobj:
        case officer2obj:
        case mg42guardobj:
        case scientistobj:
        case ssobj:
        case ssriflemanobj:
        case ssofficerobj:
        case ssofficer2obj:
        case mg42ssobj:
        case waffenssobj:
        case waffenofficerobj:
        case mg42waffenssobj:
            {
                int sounds[10]={ GRDDEATH1SND,
                    GRDDEATH2SND,
                    GRDDEATH3SND,
                    GRDDEATH4SND,
                    GRDDEATH5SND,
                    GRDDEATH6SND,
                    GRDDEATH7SND,
                    GRDDEATH8SND,
                    GRDDEATH9SND,
                };
                PlayActorVoice(sounds[Random(9)],chan_voice_guard,ob);
            }
            break;
        case sniperobj:
        case flametrooperobj:
        case chaingunnerobj:
        case rockettrooperobj:
            {
                int sounds[3]={ HEAVYDEATH1SND,
                    HEAVYDEATH2SND
                };
                PlayActorVoice(sounds[Random(2)],chan_voice_guard,ob);
            }
            break;
        case mutantobj:
            {
                int sounds[4]={ MUTANTDEATH1SND,
                    MUTANTDEATH2SND,
                    MUTANTDEATH3SND
                };
                PlayActorVoice(sounds[Random(3)],chan_voice_guard,ob);
            }
            break;
        case dogobj:
            {
                int sounds[4]={ DOGDEATH1SND,
                    DOGDEATH2SND,
                    DOGDEATH3SND
                };
                PlayActorVoice(sounds[Random(3)],chan_voice_dog,ob);
            }
            break;
        case mechtrooperobj:
            {
                int sounds[3]={ MECHDEATH1SND,
                    MECHDEATH2SND
                };
                PlayActorVoice(sounds[Random(2)],chan_voice_guard,ob);
            }
            break;
        case bossobj:
            PlayBossVoice(BOSS1DEATHSND);
            break;
        case schabbobj:
            PlayBossVoice(BOSS2DEATHSND);
            break;
        case deatharmorobj:
            ob->ambientcount = 0;
            PlayBossVoice(ROAR2SND);
            break;
        case fatobj:
            PlayBossVoice(BOSS3DEATHSND);
            GetSubtitle ("I was only following orders!");
            break;
        case panzobj:
            PlayBossVoice(BOSS4DEATHSND);
            GetSubtitle ("That's not possible!");
            break;
    }
}


/*
==================
=
= A_FlameScream
=
==================
*/

void A_FlameScream (objtype *ob)
{
    int sounds[5]={ GRDBURN1SND,
        GRDBURN2SND,
        GRDBURN3SND,
        GRDBURN4SND
    };
    PlayActorVoice(sounds[Random(4)],chan_voice_guard,ob);
}


/*
=============================================================================

GUARD

=============================================================================
*/

//
// guards
//

extern  statetype s_grdstand;

extern  statetype s_grdpath1;
extern  statetype s_grdpath1s;
extern  statetype s_grdpath2;
extern  statetype s_grdpath3;
extern  statetype s_grdpath3s;
extern  statetype s_grdpath4;

extern  statetype s_grdpain;
extern  statetype s_grdpain1;

extern  statetype s_grdgiveup;

extern  statetype s_grdshoot1;
extern  statetype s_grdshoot2;
extern  statetype s_grdshoot3;
extern  statetype s_grdshoot4;

extern  statetype s_grdchase1;
extern  statetype s_grdchase1s;
extern  statetype s_grdchase2;
extern  statetype s_grdchase3;
extern  statetype s_grdchase3s;
extern  statetype s_grdchase4;

extern  statetype s_grddie1;
extern  statetype s_grddie2;
extern  statetype s_grddie3;
extern  statetype s_grddie4;

extern  statetype s_grdgib1;
extern  statetype s_grdgib1s;
extern  statetype s_grdgib2;
extern  statetype s_grdgib3;
extern  statetype s_grdgib4;
extern  statetype s_grdgib5;
extern  statetype s_grdgib6;
extern  statetype s_grdgib7;
extern  statetype s_grdgib8;
extern  statetype s_grdgib9;

extern  statetype s_grdburn1;
extern  statetype s_grdburn2;
extern  statetype s_grdburn3;
extern  statetype s_grdburn4;
extern  statetype s_grdburn5;
extern  statetype s_grdburn6;
extern  statetype s_grdburn7;
extern  statetype s_grdburn8;
extern  statetype s_grdburn9;
extern  statetype s_grdburn10;
extern  statetype s_grdburn11;
extern  statetype s_grdburn12;
extern  statetype s_grdburn13;
extern  statetype s_grdburn14;
extern  statetype s_grdburn15;
extern  statetype s_grdburn16;
extern  statetype s_grdburn17;
extern  statetype s_grdburn18;
extern  statetype s_grdburn19;
extern  statetype s_grdburn20;

void T_GuardShoot (objtype *ob) { T_Shoot(ob); PlayActorWeapon(ATKKAR98SND,ob); }

statetype s_grdstand            = {true,SPR_GRD_S_1,0,(statefunc)T_Stand,NULL,&s_grdstand};

statetype s_grdpath1            = {true,SPR_GRD_W1_1,20,(statefunc)T_Path,NULL,&s_grdpath1s};
statetype s_grdpath1s           = {true,SPR_GRD_W1_1,5,NULL,NULL,&s_grdpath2};
statetype s_grdpath2            = {true,SPR_GRD_W2_1,15,(statefunc)T_Path,NULL,&s_grdpath3};
statetype s_grdpath3            = {true,SPR_GRD_W3_1,20,(statefunc)T_Path,NULL,&s_grdpath3s};
statetype s_grdpath3s           = {true,SPR_GRD_W3_1,5,NULL,NULL,&s_grdpath4};
statetype s_grdpath4            = {true,SPR_GRD_W4_1,15,(statefunc)T_Path,NULL,&s_grdpath1};

statetype s_grdpain             = {false,SPR_GRD_PAIN_1,10,NULL,NULL,&s_grdchase1};
statetype s_grdpain1            = {false,SPR_GRD_PAIN_2,10,NULL,NULL,&s_grdchase1};

statetype s_grdshoot1           = {false,SPR_GRD_SHOOT1,20,NULL,NULL,&s_grdshoot2};
statetype s_grdshoot2           = {false,SPR_GRD_SHOOT2,20,(statefunc)T_Aim,(statefunc)T_GuardShoot,&s_grdshoot3};
statetype s_grdshoot3           = {false,SPR_GRD_SHOOT3,20,NULL,NULL,&s_grdchase1,true};

statetype s_grdchase1           = {true,SPR_GRD_W1_1,10,(statefunc)T_Chase,NULL,&s_grdchase1s};
statetype s_grdchase1s          = {true,SPR_GRD_W1_1,3,NULL,NULL,&s_grdchase2};
statetype s_grdchase2           = {true,SPR_GRD_W2_1,8,(statefunc)T_Chase,NULL,&s_grdchase3};
statetype s_grdchase3           = {true,SPR_GRD_W3_1,10,(statefunc)T_Chase,NULL,&s_grdchase3s};
statetype s_grdchase3s          = {true,SPR_GRD_W3_1,3,NULL,NULL,&s_grdchase4};
statetype s_grdchase4           = {true,SPR_GRD_W4_1,8,(statefunc)T_Chase,NULL,&s_grdchase1};

statetype s_grddie1             = {false,SPR_GRD_DIE_1,15,NULL,(statefunc)A_DeathScream,&s_grddie2};
statetype s_grddie2             = {false,SPR_GRD_DIE_2,15,NULL,NULL,&s_grddie3};
statetype s_grddie3             = {false,SPR_GRD_DIE_3,15,NULL,NULL,&s_grddie4};
statetype s_grddie4             = {false,SPR_GRD_DEAD,0,NULL,NULL,&s_grddie4};

statetype s_grdgib1             = {false,SPR_GRD_GIB_1,1,NULL,(statefunc)A_Slurpie,&s_grdgib1s};
statetype s_grdgib1s            = {false,SPR_GRD_GIB_1,7,NULL,NULL,&s_grdgib2};
statetype s_grdgib2             = {false,SPR_GRD_GIB_2,7,NULL,NULL,&s_grdgib3};
statetype s_grdgib3             = {false,SPR_GRD_GIB_3,7,NULL,NULL,&s_grdgib4};
statetype s_grdgib4             = {false,SPR_GRD_GIB_4,7,NULL,NULL,&s_grdgib5};
statetype s_grdgib5             = {false,SPR_GRD_GIB_5,7,NULL,NULL,&s_grdgib6};
statetype s_grdgib6             = {false,SPR_GRD_GIB_6,7,NULL,NULL,&s_grdgib7};
statetype s_grdgib7             = {false,SPR_GRD_GIB_7,7,NULL,NULL,&s_grdgib8};
statetype s_grdgib8             = {false,SPR_GRD_GIB_8,7,NULL,NULL,&s_grdgib9};
statetype s_grdgib9             = {false,SPR_GRD_GIBS,0,NULL,NULL,&s_grdgib9};

statetype s_grdburn1            = {false,SPR_GRD_BURN_1,10,NULL,(statefunc)A_FlameScream,&s_grdburn2,true};
statetype s_grdburn2            = {false,SPR_GRD_BURN_2,10,NULL,NULL,&s_grdburn3,true};
statetype s_grdburn3            = {false,SPR_GRD_BURN_3,10,NULL,NULL,&s_grdburn4,true};
statetype s_grdburn4            = {false,SPR_GRD_BURN_4,10,NULL,NULL,&s_grdburn5,true};
statetype s_grdburn5            = {false,SPR_GRD_BURN_1,10,NULL,NULL,&s_grdburn6,true};
statetype s_grdburn6            = {false,SPR_GRD_BURN_2,10,NULL,NULL,&s_grdburn7,true};
statetype s_grdburn7            = {false,SPR_GRD_BURN_3,10,NULL,NULL,&s_grdburn8,true};
statetype s_grdburn8            = {false,SPR_GRD_BURN_4,10,NULL,NULL,&s_grdburn9,true};
statetype s_grdburn9            = {false,SPR_GRD_BURN_1,10,NULL,NULL,&s_grdburn10,true};
statetype s_grdburn10           = {false,SPR_GRD_BURN_2,10,NULL,NULL,&s_grdburn11,true};
statetype s_grdburn11           = {false,SPR_GRD_BURN_3,10,NULL,NULL,&s_grdburn12,true};
statetype s_grdburn12           = {false,SPR_GRD_BURN_4,10,NULL,NULL,&s_grdburn13,true};
statetype s_grdburn13           = {false,SPR_GRD_BURN_1,10,NULL,NULL,&s_grdburn14,true};
statetype s_grdburn14           = {false,SPR_GRD_BURN_2,10,NULL,NULL,&s_grdburn15,true};
statetype s_grdburn15           = {false,SPR_GRD_BURN_3,10,NULL,NULL,&s_grdburn16,true};
statetype s_grdburn16           = {false,SPR_GRD_BURN_4,10,NULL,NULL,&s_grdburn17,true};
statetype s_grdburn17           = {false,SPR_GRD_BURN_5,10,NULL,NULL,&s_grdburn18,true};
statetype s_grdburn18           = {false,SPR_GRD_BURN_6,10,NULL,NULL,&s_grdburn19,true};
statetype s_grdburn19           = {false,SPR_GRD_BURN_7,10,NULL,NULL,&s_grdburn20,true};
statetype s_grdburn20           = {false,SPR_GRD_BURNED,0,NULL,NULL,&s_grdburn20};


//
// sniper
//
extern  statetype s_sniperwait;
extern  statetype s_sniperpain1;
extern  statetype s_sniperpain2;
extern  statetype s_snipershoot1;
extern  statetype s_snipershoot2;
extern  statetype s_snipershoot3;
extern  statetype s_snipershoot4;

statetype s_sniperwait          = {0,SPR_GRD_SHOOT1,10,(statefunc)T_Sniper,NULL,&s_sniperwait};

statetype s_sniperpain          = {0,SPR_GRD_PAIN_1,10,NULL,NULL,&s_sniperwait};
statetype s_sniperpain1         = {0,SPR_GRD_PAIN_2,10,NULL,NULL,&s_sniperwait};

statetype s_snipershoot1        = {0,SPR_GRD_SHOOT1,15,(statefunc)T_Aim,NULL,&s_snipershoot2};
statetype s_snipershoot2        = {0,SPR_GRD_SHOOT2,15,(statefunc)T_Aim,(statefunc)T_GuardShoot,&s_snipershoot3};
statetype s_snipershoot3        = {0,SPR_GRD_SHOOT3,15,(statefunc)T_Aim,NULL,&s_snipershoot4,true};
statetype s_snipershoot4        = {0,SPR_GRD_SHOOT1,30,(statefunc)T_Aim,NULL,&s_sniperwait};


//
// MG42 gunner
//
extern  statetype s_mg42shoot1;
extern  statetype s_mg42shoot2;
extern  statetype s_mg42shoot3;
extern  statetype s_mg42shoot4;
extern  statetype s_mg42shoot5;
extern  statetype s_mg42shoot6;
extern  statetype s_mg42shoot7;
extern  statetype s_mg42shoot8;
extern  statetype s_mg42shoot9;
extern  statetype s_mg42shoot10;

void T_MG42Shoot (objtype *ob)  { T_Shoot(ob); PlayActorWeapon(ATKMG42SND,ob); }
void T_MG42Refire (objtype *ob) { Refire(ob,10,&s_mg42shoot2,T_MG42Shoot); }

statetype s_mg42shoot1          = {0,SPR_GRD_SHOOT1,30,(statefunc)T_Aim,(statefunc)T_MG42Shoot,&s_mg42shoot2};
statetype s_mg42shoot2          = {0,SPR_GRD_SHOOT2,3,(statefunc)T_Aim2,NULL,&s_mg42shoot3,true};
statetype s_mg42shoot3          = {0,SPR_GRD_SHOOT2,2,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mg42shoot4,true};
statetype s_mg42shoot4          = {0,SPR_GRD_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_MG42Shoot,&s_mg42shoot5,true};
statetype s_mg42shoot5          = {0,SPR_GRD_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mg42shoot6,true};
statetype s_mg42shoot6          = {0,SPR_GRD_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_MG42Shoot,&s_mg42shoot7,true};
statetype s_mg42shoot7          = {0,SPR_GRD_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mg42shoot8,true};
statetype s_mg42shoot8          = {0,SPR_GRD_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_MG42Shoot,&s_mg42shoot9,true};
statetype s_mg42shoot9          = {0,SPR_GRD_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mg42shoot10,true};
statetype s_mg42shoot10         = {0,SPR_GRD_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_MG42Refire,&s_sniperwait,true};


//
// electrode
//
extern  statetype s_electro1;
extern  statetype s_electro2;
extern  statetype s_electro3;
extern  statetype s_electro4;
extern  statetype s_electro5;
extern  statetype s_electro6;
extern  statetype s_electro7;
extern  statetype s_electro8;

void A_Spark1 (objtype *ob)   { SpawnBulletPuff(ob->x,ob->y,&s_ricochet1,(SPR_HSPARK_1-SPR_RICOCHET_1)); }
void A_Spark2 (objtype *ob)   { SpawnBulletPuff(ob->x,ob->y,&s_ricochet1,(SPR_LSPARK_1-SPR_RICOCHET_1)); }
void A_Electro (objtype *ob)  { PlaySoundLocActor(AMBELECTROSND,chan_local_loop,ob,SNDFL_CHECKDIST); }
void A_Electro1 (objtype *ob) { if(player->areanumber==ob->areanumber) A_Electro(ob); }
void A_Electro2 (objtype *ob) { if(US_RndT()>127) A_Electro1(ob); else if(US_RndT()>63) A_Spark1(ob); else A_Spark2(ob); }

statetype s_electro1            = {0,SPR_STAT_54_1,4,NULL,(statefunc)A_Electro1,&s_electro2,true};
statetype s_electro2            = {0,SPR_STAT_54_2,4,NULL,NULL,&s_electro3,true};
statetype s_electro3            = {0,SPR_STAT_54_1,4,NULL,NULL,&s_electro4,true};
statetype s_electro4            = {0,SPR_STAT_54_2,4,NULL,NULL,&s_electro5,true};
statetype s_electro5            = {0,SPR_STAT_54_1,4,NULL,(statefunc)A_Electro2,&s_electro6,true};
statetype s_electro6            = {0,SPR_STAT_54_2,4,NULL,NULL,&s_electro7,true};
statetype s_electro7            = {0,SPR_STAT_54_1,4,NULL,NULL,&s_electro8,true};
statetype s_electro8            = {0,SPR_STAT_54_2,4,NULL,NULL,&s_electro1,true};


//
// dogs
//

extern  statetype s_dogpath1;
extern  statetype s_dogpath1s;
extern  statetype s_dogpath2;
extern  statetype s_dogpath3;
extern  statetype s_dogpath3s;
extern  statetype s_dogpath4;

extern  statetype s_dogjump1;
extern  statetype s_dogjump2;
extern  statetype s_dogjump3;
extern  statetype s_dogjump4;
extern  statetype s_dogjump5;

extern  statetype s_dogchase1;
extern  statetype s_dogchase1s;
extern  statetype s_dogchase2;
extern  statetype s_dogchase3;
extern  statetype s_dogchase3s;
extern  statetype s_dogchase4;

extern  statetype s_dogdie1;
extern  statetype s_dogdie1d;
extern  statetype s_dogdie2;
extern  statetype s_dogdie3;
extern  statetype s_dogdead;

statetype s_dogpath1            = {true,SPR_DOG_W1_1,20,(statefunc)T_Path,NULL,&s_dogpath1s};
statetype s_dogpath1s           = {true,SPR_DOG_W1_1,5,NULL,NULL,&s_dogpath2};
statetype s_dogpath2            = {true,SPR_DOG_W2_1,15,(statefunc)T_Path,NULL,&s_dogpath3};
statetype s_dogpath3            = {true,SPR_DOG_W3_1,20,(statefunc)T_Path,NULL,&s_dogpath3s};
statetype s_dogpath3s           = {true,SPR_DOG_W3_1,5,NULL,NULL,&s_dogpath4};
statetype s_dogpath4            = {true,SPR_DOG_W4_1,15,(statefunc)T_Path,NULL,&s_dogpath1};

statetype s_dogjump1            = {false,SPR_DOG_JUMP1,10,NULL,NULL,&s_dogjump2};
statetype s_dogjump2            = {false,SPR_DOG_JUMP2,10,NULL,(statefunc)T_Bite,&s_dogjump3};
statetype s_dogjump3            = {false,SPR_DOG_JUMP3,10,NULL,NULL,&s_dogjump4};
statetype s_dogjump4            = {false,SPR_DOG_JUMP1,10,NULL,NULL,&s_dogjump5};
statetype s_dogjump5            = {false,SPR_DOG_W1_1,10,NULL,NULL,&s_dogchase1};

statetype s_dogchase1           = {true,SPR_DOG_W1_1,10,(statefunc)T_DogChase,NULL,&s_dogchase1s};
statetype s_dogchase1s          = {true,SPR_DOG_W1_1,3,NULL,NULL,&s_dogchase2};
statetype s_dogchase2           = {true,SPR_DOG_W2_1,8,(statefunc)T_DogChase,NULL,&s_dogchase3};
statetype s_dogchase3           = {true,SPR_DOG_W3_1,10,(statefunc)T_DogChase,NULL,&s_dogchase3s};
statetype s_dogchase3s          = {true,SPR_DOG_W3_1,3,NULL,NULL,&s_dogchase4};
statetype s_dogchase4           = {true,SPR_DOG_W4_1,8,(statefunc)T_DogChase,NULL,&s_dogchase1};

statetype s_dogdie1             = {false,SPR_DOG_DIE_1,15,NULL,(statefunc)A_DeathScream,&s_dogdie2};
statetype s_dogdie2             = {false,SPR_DOG_DIE_2,15,NULL,NULL,&s_dogdie3};
statetype s_dogdie3             = {false,SPR_DOG_DIE_3,15,NULL,NULL,&s_dogdead};
statetype s_dogdead             = {false,SPR_DOG_DEAD,0,NULL,NULL,&s_dogdead};


//
// officers
//

extern  statetype s_ofcshoot1;
extern  statetype s_ofcshoot2;
extern  statetype s_ofcshoot3;
extern  statetype s_ofcshoot4;

extern  statetype s_ofcdualshoot1;
extern  statetype s_ofcdualshoot2;
extern  statetype s_ofcdualshoot3;
extern  statetype s_ofcdualshoot4;
extern  statetype s_ofcdualshoot5;
extern  statetype s_ofcdualshoot6;

void T_OfcShoot (objtype *ob)       { T_Shoot(ob); PlayActorWeapon(ATKPISTOLSND,ob); }
void T_OfcRefire (objtype *ob)      { Refire(ob,4,&s_ofcshoot2,NULL); }
void T_OfcDualRefire (objtype *ob)  { Refire(ob,4,&s_ofcdualshoot2,NULL); }

statetype s_ofcshoot1           = {0,SPR_GRD_SHOOT1,6,NULL,NULL,&s_ofcshoot2};
statetype s_ofcshoot2           = {0,SPR_GRD_SHOOT2,5,(statefunc)T_Aim,NULL,&s_ofcshoot3};
statetype s_ofcshoot3           = {0,SPR_GRD_SHOOT2,15,(statefunc)T_Aim2,(statefunc)T_OfcShoot,&s_ofcshoot4};
statetype s_ofcshoot4           = {0,SPR_GRD_SHOOT3,10,NULL,(statefunc)T_OfcRefire,&s_grdchase1,true};

statetype s_ofcdualshoot1       = {0,SPR_GRD_SHOOT1,6,NULL,NULL,&s_ofcdualshoot2};
statetype s_ofcdualshoot2       = {0,SPR_GRD_SHOOT2,5,(statefunc)T_Aim,NULL,&s_ofcdualshoot3};
statetype s_ofcdualshoot3       = {0,SPR_GRD_SHOOT2,8,(statefunc)T_Aim2,(statefunc)T_OfcShoot,&s_ofcdualshoot4};
statetype s_ofcdualshoot4       = {0,SPR_GRD_SHOOT3,8,NULL,NULL,&s_ofcdualshoot5,true};
statetype s_ofcdualshoot5       = {0,SPR_GRD_SHOOT2,8,(statefunc)T_Aim2,(statefunc)T_OfcShoot,&s_ofcdualshoot6};
statetype s_ofcdualshoot6       = {0,SPR_GRD_SHOOT3+1,8,NULL,(statefunc)T_OfcDualRefire,&s_grdchase1,true};


//
// SS
//

extern  statetype s_ssshoot1;
extern  statetype s_ssshoot2;
extern  statetype s_ssshoot3;
extern  statetype s_ssshoot4;
extern  statetype s_ssshoot5;
extern  statetype s_ssshoot6;
extern  statetype s_ssshoot7;
extern  statetype s_ssshoot8;
extern  statetype s_ssshoot9;

void T_SSShoot (objtype *ob)    { T_Shoot(ob); if (ob->obclass==waffenssobj || ob->obclass==waffenofficerobj)
                                  PlayActorWeapon(ATKSTG44SND,ob); else PlayActorWeapon(ATKMP40SND,ob); }
void T_SSRefire (objtype *ob)   { Refire(ob,3,&s_ssshoot3,NULL); }

statetype s_ssshoot1            = {0,SPR_GRD_SHOOT1,20,NULL,NULL,&s_ssshoot2};
statetype s_ssshoot2            = {0,SPR_GRD_SHOOT2,16,(statefunc)T_Aim,NULL,&s_ssshoot3};
statetype s_ssshoot3            = {0,SPR_GRD_SHOOT2,2,NULL,NULL,&s_ssshoot4};
statetype s_ssshoot4            = {0,SPR_GRD_SHOOT2,3,(statefunc)T_Aim2,(statefunc)T_SSShoot,&s_ssshoot5};
statetype s_ssshoot5            = {0,SPR_GRD_SHOOT3,5,NULL,NULL,&s_ssshoot6,true};
statetype s_ssshoot6            = {0,SPR_GRD_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_SSShoot,&s_ssshoot7};
statetype s_ssshoot7            = {0,SPR_GRD_SHOOT3,5,NULL,NULL,&s_ssshoot8,true};
statetype s_ssshoot8            = {0,SPR_GRD_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_SSShoot,&s_ssshoot9};
statetype s_ssshoot9            = {0,SPR_GRD_SHOOT3,5,NULL,(statefunc)T_SSRefire,&s_grdchase1,true};


//
// mutant
//

extern  statetype s_mutshoot1;
extern  statetype s_mutshoot2;
extern  statetype s_mutshoot3;
extern  statetype s_mutshoot4;
extern  statetype s_mutshoot5;
extern  statetype s_mutshoot6;
extern  statetype s_mutshoot7;
extern  statetype s_mutshoot8;
extern  statetype s_mutshoot9;
extern  statetype s_mutshoot10;

extern  statetype s_mutburn1;

void T_MutShoot (objtype *ob)   { T_Shoot(ob); PlayActorWeapon(MUTANTFIRESND,ob); }
void T_MutRefire (objtype *ob)  { Refire(ob,3,&s_mutshoot2,T_MutShoot); }

statetype s_mutshoot1           = {0,SPR_GRD_SHOOT1,10,NULL,NULL,&s_mutshoot2};
statetype s_mutshoot2           = {0,SPR_GRD_SHOOT1,5,(statefunc)T_Aim,(statefunc)T_MutShoot,&s_mutshoot3};
statetype s_mutshoot3           = {0,SPR_GRD_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mutshoot4,true};
statetype s_mutshoot4           = {0,SPR_GRD_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mutshoot5,true};
statetype s_mutshoot5           = {0,SPR_GRD_SHOOT3,5,(statefunc)T_Aim2,NULL,&s_mutshoot6,true};
statetype s_mutshoot6           = {0,SPR_GRD_SHOOT1,5,(statefunc)T_Aim2,(statefunc)T_MutShoot,&s_mutshoot7};
statetype s_mutshoot7           = {0,SPR_GRD_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mutshoot8,true};
statetype s_mutshoot8           = {0,SPR_GRD_SHOOT3+1,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mutshoot9,true};
statetype s_mutshoot9           = {0,SPR_GRD_SHOOT3,5,(statefunc)T_Aim2,NULL,&s_mutshoot10,true};
statetype s_mutshoot10          = {0,SPR_GRD_SHOOT1,5,(statefunc)T_Aim2,(statefunc)T_MutRefire,&s_grdchase1};

statetype s_mutburn1            = {false,SPR_GRD_BURN_1,10,NULL,(statefunc)A_DeathScream,&s_grdburn2,true};


//
// Mechanoid Stormtrooper
//
extern  statetype s_mststand;
extern  statetype s_mstdormant;

extern  statetype s_mstpath1;
extern  statetype s_mstpath1s;
extern  statetype s_mstpath2;
extern  statetype s_mstpath3;
extern  statetype s_mstpath3s;
extern  statetype s_mstpath4;

extern  statetype s_mstshoot1;
extern  statetype s_mstshoot2;
extern  statetype s_mstshoot3;
extern  statetype s_mstshoot4;
extern  statetype s_mstshoot5;
extern  statetype s_mstshoot6;
extern  statetype s_mstshoot7;
extern  statetype s_mstshoot8;
extern  statetype s_mstshoot9;
extern  statetype s_mstshoot10;

extern  statetype s_mstchase1;
extern  statetype s_mstchase1s;
extern  statetype s_mstchase2;
extern  statetype s_mstchase3;
extern  statetype s_mstchase3s;
extern  statetype s_mstchase4;

extern  statetype s_mstdie1;
extern  statetype s_mstdie2;
extern  statetype s_mstdie3;
extern  statetype s_mstdie4;
extern  statetype s_mstdie5;
extern  statetype s_mstdie6;

void T_MSTRefire (objtype *ob)  { Refire(ob,5,&s_mstshoot2,T_MG42Shoot); }

statetype s_mststand            = {true,SPR_MST_W1_1,0,(statefunc)T_Stand,NULL,&s_mststand};
statetype s_mstdormant          = {false,SPR_MST_DORMANT,0,(statefunc)T_Stand,NULL,&s_mstdormant};

statetype s_mstpath1            = {true,SPR_MST_W1_1,20,(statefunc)T_Path,NULL,&s_mstpath1s};
statetype s_mstpath1s           = {true,SPR_MST_W1_1,5,NULL,NULL,&s_mstpath2};
statetype s_mstpath2            = {true,SPR_MST_W2_1,15,(statefunc)T_Path,NULL,&s_mstpath3};
statetype s_mstpath3            = {true,SPR_MST_W3_1,20,(statefunc)T_Path,NULL,&s_mstpath3s};
statetype s_mstpath3s           = {true,SPR_MST_W3_1,5,NULL,NULL,&s_mstpath4};
statetype s_mstpath4            = {true,SPR_MST_W4_1,15,(statefunc)T_Path,NULL,&s_mstpath1};

statetype s_mstchase1           = {true,SPR_MST_W1_1,10,(statefunc)T_Chase,NULL,&s_mstchase1s};
statetype s_mstchase1s          = {true,SPR_MST_W1_1,3,NULL,NULL,&s_mstchase2};
statetype s_mstchase2           = {true,SPR_MST_W2_1,8,(statefunc)T_Chase,NULL,&s_mstchase3};
statetype s_mstchase3           = {true,SPR_MST_W3_1,10,(statefunc)T_Chase,NULL,&s_mstchase3s};
statetype s_mstchase3s          = {true,SPR_MST_W3_1,3,NULL,NULL,&s_mstchase4};
statetype s_mstchase4           = {true,SPR_MST_W4_1,8,(statefunc)T_Chase,NULL,&s_mstchase1};

statetype s_mstdie1             = {false,SPR_MST_DIE_1,5,NULL,(statefunc)A_Spark1,&s_mstdie2};
statetype s_mstdie2             = {false,SPR_MST_DIE_1,5,NULL,(statefunc)A_DeathScream,&s_mstdie3};
statetype s_mstdie3             = {false,SPR_MST_DIE_2,10,NULL,(statefunc)A_Spark1,&s_mstdie4};
statetype s_mstdie4             = {false,SPR_MST_DIE_3,10,NULL,(statefunc)A_Spark2,&s_mstdie5};
statetype s_mstdie5             = {false,SPR_MST_DIE_4,10,NULL,NULL,&s_mstdie6};
statetype s_mstdie6             = {false,SPR_MST_DEAD,0,NULL,NULL,&s_mstdie6};

statetype s_mstshoot1           = {0,SPR_MST_SHOOT1,30,(statefunc)T_Aim,(statefunc)T_MG42Shoot,&s_mstshoot2};
statetype s_mstshoot2           = {0,SPR_MST_SHOOT2,3,(statefunc)T_Aim2,NULL,&s_mstshoot3,true};
statetype s_mstshoot3           = {0,SPR_MST_SHOOT2,2,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mstshoot4,true};
statetype s_mstshoot4           = {0,SPR_MST_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_MG42Shoot,&s_mstshoot5,true};
statetype s_mstshoot5           = {0,SPR_MST_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mstshoot6,true};
statetype s_mstshoot6           = {0,SPR_MST_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_MG42Shoot,&s_mstshoot7,true};
statetype s_mstshoot7           = {0,SPR_MST_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mstshoot8,true};
statetype s_mstshoot8           = {0,SPR_MST_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_MG42Shoot,&s_mstshoot9,true};
statetype s_mstshoot9           = {0,SPR_MST_SHOOT2,5,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_mstshoot10,true};
statetype s_mstshoot10          = {0,SPR_MST_SHOOT3,5,(statefunc)T_Aim2,(statefunc)T_MSTRefire,&s_mstchase1,true};


//
// hans
//
extern  statetype s_bossstand;

extern  statetype s_bosschase1;
extern  statetype s_bosschase1s;
extern  statetype s_bosschase2;
extern  statetype s_bosschase3;
extern  statetype s_bosschase3s;
extern  statetype s_bosschase4;

extern  statetype s_bossdie1;
extern  statetype s_bossdie2;
extern  statetype s_bossdie3;
extern  statetype s_bossdie4;

extern  statetype s_bossshoot1;
extern  statetype s_bossshoot2;
extern  statetype s_bossshoot3;
extern  statetype s_bossshoot4;
extern  statetype s_bossshoot5;
extern  statetype s_bossshoot6;
extern  statetype s_bossshoot7;
extern  statetype s_bossshoot8;
extern  statetype s_bossshoot9;
extern  statetype s_bossshoot10;
extern  statetype s_bossshoot11;
extern  statetype s_bossshoot12;
extern  statetype s_bossshoot13;
extern  statetype s_bossshoot14;
extern  statetype s_bossshoot15;
extern  statetype s_bossshoot16;
extern  statetype s_bossshoot17;
extern  statetype s_bossshoot18;

extern  statetype s_bosslaunch1;
extern  statetype s_bosslaunch2;
extern  statetype s_bosslaunch3;
extern  statetype s_bosslaunch4;

void T_BossShoot (objtype *ob)    { T_Shoot(ob); if(ob->obclass==flametrooperobj) PlayActorWeapon(FLAMETHROWERSND,newobj);
                                    else PlayActorWeapon(ATKCHAINGUNSND,ob); }
void T_BossShoot2 (objtype *ob)   { T_Shoot(ob); if(ob->obclass!=flametrooperobj) PlayActorWeapon(ATKCHAINGUNSND,ob); }
void T_BossRefire (objtype *ob)   { Refire(ob,3,&s_bossshoot2,T_BossShoot); }
void T_RocketShoot (objtype *ob)  { ProjFire(ob,rocketobj,&s_rocket,0x4000l,0); PlayActorWeapon(MISSILEFIRESND,newobj); }

statetype s_bossstand           = {false,SPR_BOSS_W1,0,(statefunc)T_Stand,NULL,&s_bossstand};

statetype s_bosschase1          = {false,SPR_BOSS_W1,10,(statefunc)T_Chase,NULL,&s_bosschase1s};
statetype s_bosschase1s         = {false,SPR_BOSS_W1,3,NULL,NULL,&s_bosschase2};
statetype s_bosschase2          = {false,SPR_BOSS_W2,8,(statefunc)T_Chase,NULL,&s_bosschase3};
statetype s_bosschase3          = {false,SPR_BOSS_W3,10,(statefunc)T_Chase,NULL,&s_bosschase3s};
statetype s_bosschase3s         = {false,SPR_BOSS_W3,3,NULL,NULL,&s_bosschase4};
statetype s_bosschase4          = {false,SPR_BOSS_W4,8,(statefunc)T_Chase,NULL,&s_bosschase1};

statetype s_bossdie1            = {false,SPR_BOSS_DIE1,15,NULL,(statefunc)A_DeathScream,&s_bossdie2};
statetype s_bossdie2            = {false,SPR_BOSS_DIE2,15,NULL,NULL,&s_bossdie3};
statetype s_bossdie3            = {false,SPR_BOSS_DIE3,15,NULL,NULL,&s_bossdie4};
statetype s_bossdie4            = {false,SPR_BOSS_DEAD,0,NULL,NULL,&s_bossdie4};

statetype s_bossshoot1          = {0,SPR_BOSS_SHOOT1,30,(statefunc)T_Aim,(statefunc)T_BossShoot,&s_bossshoot2};
statetype s_bossshoot2          = {0,SPR_BOSS_SHOOT2,2,(statefunc)T_Aim2,NULL,&s_bossshoot3,true};
statetype s_bossshoot3          = {0,SPR_BOSS_SHOOT2,2,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot4,true};
statetype s_bossshoot4          = {0,SPR_BOSS_SHOOT3,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot5,true};
statetype s_bossshoot5          = {0,SPR_BOSS_SHOOT2,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot6,true};
statetype s_bossshoot6          = {0,SPR_BOSS_SHOOT3,4,(statefunc)T_Aim2,(statefunc)T_BossShoot2,&s_bossshoot7,true};
statetype s_bossshoot7          = {0,SPR_BOSS_SHOOT2,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot8,true};
statetype s_bossshoot8          = {0,SPR_BOSS_SHOOT3,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot9,true};
statetype s_bossshoot9          = {0,SPR_BOSS_SHOOT2,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot10,true};
statetype s_bossshoot10         = {0,SPR_BOSS_SHOOT3,4,(statefunc)T_Aim2,(statefunc)T_BossShoot,&s_bossshoot11,true};
statetype s_bossshoot11         = {0,SPR_BOSS_SHOOT2,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot12,true};
statetype s_bossshoot12         = {0,SPR_BOSS_SHOOT3,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot13,true};
statetype s_bossshoot13         = {0,SPR_BOSS_SHOOT2,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot14,true};
statetype s_bossshoot14         = {0,SPR_BOSS_SHOOT3,4,(statefunc)T_Aim2,(statefunc)T_BossShoot2,&s_bossshoot15,true};
statetype s_bossshoot15         = {0,SPR_BOSS_SHOOT2,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot16,true};
statetype s_bossshoot16         = {0,SPR_BOSS_SHOOT3,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot17,true};
statetype s_bossshoot17         = {0,SPR_BOSS_SHOOT2,4,(statefunc)T_Aim2,(statefunc)T_Shoot,&s_bossshoot18,true};
statetype s_bossshoot18         = {0,SPR_BOSS_SHOOT3,4,(statefunc)T_Aim2,(statefunc)T_BossRefire,&s_bosschase1,true};

statetype s_bosslaunch1         = {0,SPR_BOSS_SHOOT1,20,NULL,NULL,&s_bosslaunch2};
statetype s_bosslaunch2         = {0,SPR_BOSS_SHOOT2,20,(statefunc)T_Aim,(statefunc)T_RocketShoot,&s_bosslaunch3};
statetype s_bosslaunch3         = {0,SPR_BOSS_SHOOT3,20,NULL,NULL,&s_bosslaunch4,true};
statetype s_bosslaunch4         = {0,SPR_BOSS_SHOOT2,20,NULL,NULL,&s_bosschase1};


//
// schabb
//
extern  statetype s_schabbshoot1;
extern  statetype s_schabbshoot2;
extern  statetype s_schabbshoot3;
extern  statetype s_schabbshoot4;
extern  statetype s_schabbshoot5;
extern  statetype s_schabbshoot6;
extern  statetype s_schabbshoot7;

extern  statetype s_needle1;
extern  statetype s_needle2;
extern  statetype s_needle3;
extern  statetype s_needle4;

void T_SchabbThrowR (objtype *ob)   { ProjOffsFire(ob,needleobj,&s_needle1,0x3000l,0,1); }
void T_SchabbThrowL (objtype *ob)   { ProjOffsFire(ob,needleobj,&s_needle3,0x3000l,0,2); }
void T_SchabbShoot1 (objtype *ob)   { PlayActorWeapon(ATKSTG44SND,ob); T_Shoot(ob); }
void T_SchabbShoot2 (objtype *ob)   { T_SchabbShoot1(ob); T_SchabbThrowR(ob); T_SchabbThrowL(ob); }

statetype s_schabbshoot1        = {0,SPR_BOSS_SHOOT1,30,(statefunc)T_Aim,(statefunc)T_SchabbShoot2,&s_schabbshoot2};
statetype s_schabbshoot2        = {0,SPR_BOSS_SHOOT2,12,(statefunc)T_Aim2,(statefunc)T_SchabbShoot1,&s_schabbshoot3,true};
statetype s_schabbshoot3        = {0,SPR_BOSS_SHOOT3,12,(statefunc)T_Aim2,(statefunc)T_SchabbShoot2,&s_schabbshoot4,true};
statetype s_schabbshoot4        = {0,SPR_BOSS_SHOOT2,12,(statefunc)T_Aim2,(statefunc)T_SchabbShoot1,&s_schabbshoot5,true};
statetype s_schabbshoot5        = {0,SPR_BOSS_SHOOT3,12,(statefunc)T_Aim2,(statefunc)T_SchabbShoot2,&s_schabbshoot6,true};
statetype s_schabbshoot6        = {0,SPR_BOSS_SHOOT2,12,(statefunc)T_Aim2,(statefunc)T_SchabbShoot1,&s_schabbshoot7,true};
statetype s_schabbshoot7        = {0,SPR_BOSS_SHOOT3,12,(statefunc)T_Aim2,NULL,&s_bosschase1,true};

statetype s_needle1             = {false,SPR_HYPO1,6,(statefunc)T_Projectile,NULL,&s_needle2};
statetype s_needle2             = {false,SPR_HYPO2,6,(statefunc)T_Projectile,NULL,&s_needle3};
statetype s_needle3             = {false,SPR_HYPO3,6,(statefunc)T_Projectile,NULL,&s_needle4};
statetype s_needle4             = {false,SPR_HYPO4,6,(statefunc)T_Projectile,NULL,&s_needle1};


//
// Narbengesicht
//
extern  statetype s_narbdie1;
extern  statetype s_narbdie2;
extern  statetype s_narbdie3;
extern  statetype s_narbdie4;
extern  statetype s_narbdie5;

extern  statetype s_narbshoot1;
extern  statetype s_narbshoot2;

statetype s_narbdie1            = {0,SPR_BOSS_W1,1,NULL,(statefunc)A_DeathScream,&s_narbdie2};
statetype s_narbdie2            = {0,SPR_BOSS_W1,200,NULL,NULL,&s_narbdie3};
statetype s_narbdie3            = {0,SPR_BOSS_DIE1,10,NULL,NULL,&s_narbdie4};
statetype s_narbdie4            = {0,SPR_BOSS_DIE2,10,NULL,NULL,&s_narbdie5};
statetype s_narbdie5            = {0,SPR_BOSS_DIE3,10,NULL,NULL,&s_bossdie4};

statetype s_narbshoot1          = {0,SPR_BOSS_SHOOT1,30,(statefunc)T_Aim,(statefunc)T_RocketShoot,&s_narbshoot2};
statetype s_narbshoot2          = {0,SPR_BOSS_W1-1,10,(statefunc)T_Aim2,(statefunc)T_BossShoot,&s_bossshoot2,true};


//
// panz
//
extern  statetype s_panzdie1;
extern  statetype s_panzdie2;
extern  statetype s_panzdie3;

extern  statetype s_panzshoot1;
extern  statetype s_panzshoot2;

void T_PanzShootR (objtype *ob) { ProjOffsFire(ob,rocketobj,&s_rocket,0x4000l,(SPR_HROCKET_1-SPR_ROCKET_1),1); }
void T_PanzShootL (objtype *ob) { ProjOffsFire(ob,rocketobj,&s_rocket,0x4000l,(SPR_HROCKET_1-SPR_ROCKET_1),2); }
void T_PanzShoot (objtype *ob)  { T_PanzShootR(ob); T_PanzShootL(ob); PlayActorWeapon(MISSILEFIRESND,ob); }

statetype s_panzdie1            = {false,SPR_BOSS_W1,1,NULL,(statefunc)A_DeathScream,&s_panzdie2};
statetype s_panzdie2            = {false,SPR_BOSS_W1,150,NULL,NULL,&s_panzdie3};
statetype s_panzdie3            = {false,SPR_BOSS_DIE1,15,NULL,NULL,&s_bossdie2};

statetype s_panzshoot1          = {0,SPR_BOSS_SHOOT1,20,(statefunc)T_Aim,(statefunc)T_PanzShoot,&s_panzshoot2};
statetype s_panzshoot2          = {0,SPR_BOSS_W1-1,20,(statefunc)T_Aim2,(statefunc)T_BossShoot,&s_bossshoot2,true};


//
// Death Mutant
//
extern  statetype s_mechadie1;
extern  statetype s_mechadie2;
extern  statetype s_mechadie3;
extern  statetype s_mechadie4;
extern  statetype s_mechadie5;
extern  statetype s_mechares1;
extern  statetype s_mechares2;
extern  statetype s_mechares3;

extern  statetype s_mechashoot1;
extern  statetype s_mechashoot2;

extern  statetype s_totenchase1;
extern  statetype s_totenchase2;

extern  statetype s_totenfade1;
extern  statetype s_totenfade2;
extern  statetype s_totenfade3;
extern  statetype s_totenfade4;

void T_TotenLaunch (objtype *ob)    { ProjFire(ob,rocketobj,&s_erocket1,0x3000l,(SPR_EROCKET_1-SPR_ROCKET_1));
                                      PlayActorWeapon(MISSILEFIRESND,newobj); }
void A_Resurrect (objtype *ob);

statetype s_mechadie1           = {false,SPR_BOSS_DIE1,1,NULL,(statefunc)A_DeathScream,&s_mechadie2};
statetype s_mechadie2           = {false,SPR_BOSS_DIE1,15,NULL,(statefunc)A_HitlerMorph,&s_mechadie3};
statetype s_mechadie3           = {false,SPR_BOSS_DIE2,15,NULL,NULL,&s_mechadie4};
statetype s_mechadie4           = {false,SPR_BOSS_DIE3,15,NULL,NULL,&s_mechadie5};
statetype s_mechadie5           = {false,SPR_BOSS_DEAD,TOTENDELAYTICS,NULL,(statefunc)A_Resurrect,&s_mechares1};
statetype s_mechares1           = {false,SPR_BOSS_DIE3,15,NULL,NULL,&s_mechares2};
statetype s_mechares2           = {false,SPR_BOSS_DIE2,15,NULL,NULL,&s_mechares3};
statetype s_mechares3           = {false,SPR_BOSS_DIE1,15,NULL,NULL,&s_bosschase1};

statetype s_mechashoot1         = {0,SPR_BOSS_SHOOT1,20,(statefunc)T_Aim,(statefunc)T_TotenLaunch,&s_mechashoot2,true};
statetype s_mechashoot2         = {0,SPR_BOSS_W1-1,20,(statefunc)T_Aim2,(statefunc)T_BossShoot,&s_bossshoot2,true};

statetype s_totenchase1         = {false,SPR_TOTEN_W1,10,NULL,NULL,&s_totenchase2,true};
statetype s_totenchase2         = {false,SPR_TOTEN_W1,TOTENDELAYTICS,(statefunc)T_Ghosts,NULL,&s_totenfade1,true};

statetype s_totenfade1          = {false,SPR_TOTEN_F1,12,NULL,NULL,&s_totenfade2,true};
statetype s_totenfade2          = {false,SPR_TOTEN_F2,12,NULL,NULL,&s_totenfade3,true};
statetype s_totenfade3          = {false,SPR_TOTEN_F3,12,NULL,NULL,&s_totenfade4,true};
statetype s_totenfade4          = {false,SPR_TOTEN_F4,12,NULL,NULL,NULL,true};


////////////////////////////////////////////////////////
//
// A_HitlerMorph
// A_Resurrect
// A_Slurpie
//
////////////////////////////////////////////////////////
void A_HitlerMorph (objtype *ob)
{
    for (int i=0; i<MAXDOORS; i++) { if (doorobjlist[i].lock==dr_toten) OpenDoor(i); }

    SpawnNewObj (ob->tilex,ob->tiley,&s_totenchase1);
    newobj->speed = SPDPATROL*6;

    newobj->x = ob->x;
    newobj->y = ob->y;

    newobj->distance = ob->distance;
    newobj->dir = ob->dir;
    newobj->flags = FL_NEVERMARK;

    newobj->obclass = ghostobj;
    actorat[ob->tilex][ob->tiley] = (objtype *) BLOCKTILE;
}

void A_Resurrect (objtype *ob)
{
    ob->flags &= ~FL_NONMARK;
    ob->flags |= FL_SHOOTABLE;
    ob->flags |= FL_ATTACKMODE;
    ob->hitpoints = starthitpoints[gamestate.difficulty][ob->obclass];
    if (CheckBoss(ob))
        gamestate.startbosshp += ob->hitpoints;
    actorat[ob->tilex][ob->tiley] = ob;
    A_AlertSound (ob);
}

void A_Slurpie (objtype *ob)
{
    PlayActorVoice(SLURPIESND,chan_voice_guard,ob);
}


/*
===============
=
= CheckBoss
=
= WSJ: returns true if ob's hitpoints
= should be included in the boss meter
= when player is fighting it
=
===============
*/

boolean CheckBoss (objtype *ob)
{
    switch (ob->obclass)
    {
        case bossobj:
        case deatharmorobj:
        case schabbobj:
        case fatobj:
        case panzobj:
            return true;
    }
    return false;
}


/*
===============
=
= SpawnStand
=
===============
*/

void SpawnStand (int which, int tilex, int tiley, int dir, short spriteoffset)
{
    word tile;

    uint32_t flags = FL_SHOOTABLE|FL_BONUS;

    switch (which)
    {
        case guardobj:
        case riflemanobj:
        case infantryobj:
        case officerobj:
        case officer2obj:
        case ssobj:
        case ssriflemanobj:
        case ssofficerobj:
        case ssofficer2obj:
        case waffenofficerobj:
        case waffenssobj:
        case scientistobj:
        case mutantobj:
            SpawnNewObj (tilex,tiley,&s_grdstand);
            newobj->speed = SPDPATROL;
            break;

        case mechtrooperobj:
            if (dir == nodir)
            {
                SpawnNewObj (tilex,tiley,&s_mstdormant);
                newobj->alert = alert_dormant;
            }
            else
                SpawnNewObj (tilex,tiley,&s_mststand);
            newobj->speed = SPDPATROL;
            break;

        case mg42guardobj:
        case mg42ssobj:
        case mg42waffenssobj:
            flags |= FL_AMBUSH;
        case sniperobj:
            SpawnNewObj (tilex,tiley,&s_sniperwait);
            break;

        case flametrooperobj:
        case chaingunnerobj:
        case rockettrooperobj:
        case bossobj:
        case schabbobj:
        case fatobj:
        case panzobj:
        case deatharmorobj:
            SpawnNewObj (tilex,tiley,&s_bossstand);
            newobj->speed = SPDPATROL;
            break;
    }

    newobj->flags = flags;

    switch (MAPSPOT(tilex,tiley,0))
    {
        case AMBUSHTILE:
            newobj->flags |= FL_AMBUSH;
            break;
        case AREATILE:
            newobj->active = ac_yes;
            break;
        case DORMANT1TILE:
        case DORMANT2TILE:
            newobj->alert = alert_dormant;
            break;
    }
    PlaceValidArea(tilex,tiley);
    newobj->areanumber = AreaAt(tilex,tiley);

    newobj->obclass = (classtype)which;
    newobj->hitpoints = starthitpoints[gamestate.difficulty][which];
    if ((dirtype)dir == nodir) newobj->dir = nodir;
    else newobj->dir = (dirtype)(dir * 2);
    newobj->sproffset = spriteoffset;

    if (!loadedgame && newobj->flags & FL_BONUS)
        gamestate.killtotal++;
}


/*
===============
=
= SpawnPatrol
=
===============
*/

void SpawnPatrol (int which, int tilex, int tiley, int dir, short spriteoffset)
{
    uint32_t flags = FL_SHOOTABLE|FL_BONUS;

    switch (which)
    {
        case guardobj:
        case riflemanobj:
        case infantryobj:
        case officerobj:
        case officer2obj:
        case ssobj:
        case ssriflemanobj:
        case ssofficerobj:
        case ssofficer2obj:
        case waffenofficerobj:
        case waffenssobj:
        case scientistobj:
        case mutantobj:
            SpawnNewObj (tilex,tiley,&s_grdpath1);
            newobj->speed = SPDPATROL;
            break;

        case mechtrooperobj:
            SpawnNewObj (tilex,tiley,&s_mstpath1);
            newobj->speed = SPDPATROL;
            break;

        case dogobj:
            SpawnNewObj (tilex,tiley,&s_dogpath1);
            newobj->speed = SPDDOG;
            break;
    }

    newobj->flags = flags;
    newobj->obclass = (classtype)which;
    if ((dirtype)dir == nodir) newobj->dir = nodir;
    else newobj->dir = (dirtype)(dir * 2);
    newobj->hitpoints = starthitpoints[gamestate.difficulty][which];
    newobj->distance = TILEGLOBAL;
    newobj->sproffset = spriteoffset;

    if (!loadedgame && newobj->flags & FL_BONUS)
        gamestate.killtotal++;

    newobj->active = ac_yes;
    actorat[newobj->tilex][newobj->tiley] = NULL;           // don't use original spot

    switch (dir)
    {
        case 0:
            newobj->tilex++;
            break;
        case 1:
            newobj->tiley--;
            break;
        case 2:
            newobj->tilex--;
            break;
        case 3:
            newobj->tiley++;
            break;
    }

    actorat[newobj->tilex][newobj->tiley] = newobj;
}


/*
===============
=
= SpawnElectrode
=
===============
*/

void SpawnElectrode (int tilex, int tiley)
{
    SpawnNewObj (tilex,tiley,&s_electro1);
    newobj->obclass = inertobj;
    newobj->flags |= FL_NONMARK;
    actorat[tilex][tiley] = (objtype *) BLOCKTILE;
}


/*
============================================================================

STAND

============================================================================
*/


/*
===============
=
= T_Stand
=
===============
*/

void T_Stand (objtype *ob)
{
    SightPlayer (ob);
}


/*
===============
=
= T_Sniper
=
= WSJ: enemy just stands there and waits until the player
= is in his sights, then he fires
=
===============
*/

void T_Sniper (objtype *ob)
{
    if (gamestate.victoryflag)
        return;

    if (!(ob->flags & FL_ATTACKMODE))
    {
        SightPlayer (ob);
        return;
    }

    if (CheckLine(ob))                                              // got a shot at player?
    {
        if ( (unsigned) US_RndT() < (tics<<3) )
        {
            //
            // go into attack frame
            //
            switch (ob->obclass)
            {
                case sniperobj:
                    NewState (ob,&s_snipershoot1);
                    break;
                case mg42guardobj:
                case mg42ssobj:
                case mg42waffenssobj:
                    ob->temp1 = 0;
                    NewState (ob,&s_mg42shoot1);
                    break;
            }

            return;
        }
    }
}


/*
============================================================================

CHASE

============================================================================
*/

/*
=================
=
= T_Chase
=
=================
*/

void T_Chase (objtype *ob)
{
    int32_t move,target;
    int     dx,dy,dist,chance;
    boolean dodge;

    if (gamestate.victoryflag)
        return;

    dodge = false;
    if (CheckLine(ob))      // got a shot at player?
    {
        ob->hidden = false;
        dx = abs(ob->tilex - player->tilex);
        dy = abs(ob->tiley - player->tiley);
        dist = dx>dy ? dx : dy;

        chance = 300;
        switch (ob->obclass)
        {
            case riflemanobj:
            case ssriflemanobj:
            case rockettrooperobj:
                if (dist > 1)
                    chance = (tics<<3); // WSJ: enemy has a long range weapon
                break;
            case waffenssobj:
            case waffenofficerobj:
            case fatobj:
            case deatharmorobj:
            case panzobj:
                if (dist > 1)
                    chance = ((tics<<5)/dist)*2;
                break;
            case flametrooperobj:
                if (dist > 7)
                    chance = -1;    // WSJ: out of flamethrower range
                else
                    chance = (tics<<3);
                break;
            default:
                if (dist > 1)
                    chance = (tics<<5)/dist;
        }

        if ( US_RndT()<chance && !invisiblemode)
        {
            //
            // go into attack frame
            //
            ob->temp1 = 0;
            switch (ob->obclass)
            {
                case riflemanobj:
                case ssriflemanobj:
                    NewState (ob,&s_grdshoot1);
                    break;
                case guardobj:
                case officerobj:
                case scientistobj:
                    NewState (ob,&s_ofcshoot1);
                    break;
                case mutantobj:
                    NewState (ob,&s_mutshoot1);
                    break;
                case infantryobj:
                case officer2obj:
                case ssobj:
                case ssofficerobj:
                case waffenssobj:
                case waffenofficerobj:
                    NewState (ob,&s_ssshoot1);
                    break;
                case ssofficer2obj:
                    NewState (ob,&s_ofcdualshoot1);
                    break;
                case mechtrooperobj:
                    NewState (ob,&s_mstshoot1);
                    break;
                case bossobj:
                case chaingunnerobj:
                case flametrooperobj:
                    NewState (ob,&s_bossshoot1);
                    break;
                case rockettrooperobj:
                    NewState (ob,&s_bosslaunch1);
                    break;
                case schabbobj:
                    NewState (ob,&s_schabbshoot1);
                    break;
                case fatobj:
                    NewState (ob,&s_narbshoot1);
                    break;
                case deatharmorobj:
                    NewState (ob,&s_mechashoot1);
                    break;
                case panzobj:
                    NewState (ob,&s_panzshoot1);
                    break;
            }
            return;
        }
        dodge = true;
    }
    else
        ob->hidden = true;

    if (ob->dir == nodir)
    {
        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            DEMOIF_SDL
            {
                TryWalk(ob);
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        if (dodge)
            SelectDodgeDir (ob);
        else
            SelectChaseDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}


/*
=================
=
= T_Ghosts
=
=================
*/

void T_Ghosts (objtype *ob)
{
    int32_t move;

    if (ob->dir == nodir)
    {
        SelectNextDir(ob, (byte)player->tilex, (byte)player->tiley);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        SelectNextDir(ob, (byte)player->tilex, (byte)player->tiley);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}

/*
=================
=
= T_DogChase
=
=================
*/

void T_DogChase (objtype *ob)
{
    int32_t    move;
    int32_t    dx,dy;


    if (ob->dir == nodir)
    {
        SelectDodgeDir (ob);
        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }

    move = ob->speed*tics;

    while (move)
    {
        //
        // check for byte range
        //
        dx = player->x - ob->x;
        if (dx<0)
            dx = -dx;
        dx -= move;
        if (dx <= MINACTORDIST)
        {
            dy = player->y - ob->y;
            if (dy<0)
                dy = -dy;
            dy -= move;
            if (dy <= MINACTORDIST)
            {
                NewState (ob,&s_dogjump1);
                return;
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        //
        // reached goal tile, so select another one
        //

        //
        // fix position to account for round off during moving
        //
        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;

        move -= ob->distance;

        SelectDodgeDir (ob);

        if (ob->dir == nodir)
            return;                                                 // object is blocked in
    }
}



/*
============================================================================

                                    PATH

============================================================================
*/


/*
===============
=
= SelectPathDir
=
===============
*/

void SelectPathDir (objtype *ob)
{
    unsigned spot;

    spot = MAPSPOT(ob->tilex,ob->tiley,1)-ICONARROWS;

    if (spot<8)
    {
        // new direction
        ob->dir = (dirtype)(spot);
    }

    ob->distance = TILEGLOBAL;

    if (!TryWalk (ob))
        ob->dir = nodir;
}


/*
===============
=
= T_Path
=
===============
*/

void T_Path (objtype *ob)
{
    int32_t    move;

    if (SightPlayer (ob))
        return;

    if (ob->dir == nodir)
    {
        SelectPathDir (ob);
        if (ob->dir == nodir)
            return;                                 // all movement is blocked
    }


    move = ob->speed*tics;

    while (move)
    {
        if (ob->distance < 0)
        {
            //
            // waiting for a door to open
            //
            OpenDoor (-ob->distance-1);
            if (doorobjlist[-ob->distance-1].action != dr_open)
                return;
            ob->distance = TILEGLOBAL;      // go ahead, the door is now open
            DEMOIF_SDL
            {
                TryWalk(ob);
            }
        }

        if (move < ob->distance)
        {
            MoveObj (ob,move);
            break;
        }

        if (ob->tilex>MAPSIZE || ob->tiley>MAPSIZE)
        {
            sprintf (str, "T_Path hit a wall at %u,%u, dir %u",
                ob->tilex,ob->tiley,ob->dir);
            Quit (str);
        }

        ob->x = ((int32_t)ob->tilex<<TILESHIFT)+TILEGLOBAL/2;
        ob->y = ((int32_t)ob->tiley<<TILESHIFT)+TILEGLOBAL/2;
        move -= ob->distance;

        SelectPathDir (ob);

        if (ob->dir == nodir)
            return;                                 // all movement is blocked
    }
}


/*
=============================================================================

                                    FIGHT

=============================================================================
*/


/*
=================
=
= Refire
=
= WSJ: for looped attacks (ex: machine gun fire)
=
=================
*/

void Refire (objtype *ob, short maxrepeat, statetype *state, void (*Action)(objtype *))
{
    if (++ob->temp1 >= maxrepeat || !CheckLine(ob))
        return;

    ob->state = state;
    ob->ticcount = state->tictime;

    if (Action != NULL)
        Action (ob);
}


/*
============
=
= T_Aim
=
============
*/

void T_Aim (objtype *ob)
{
    int32_t deltax,deltay;
    float   angle;
    int     iangle;

    deltax = player->x - ob->x;
    deltay = ob->y - player->y;
    angle = (float) atan2((float) deltay, (float) deltax);
    if (angle<0)
        angle = (float) (M_PI*2+angle);
    iangle = (int) (angle/(M_PI*2)*ANGLES);
    ob->angle = iangle;
}

void T_Aim2 (objtype *ob)
{
    if (CheckLine(ob))
        T_Aim(ob);
}


/*
===============
=
= InstantShot
=
= WSJ: based on the old T_Shoot code
= Returns true if player was hit
=
===============
*/

boolean InstantShot (objtype *ob)
{
    int     dx,dy,dist;
    int     hitchance,damage;

    hitchance = 128;

    if (CheckLine (ob))                    // player is not behind a wall
    {
        dx = abs(ob->tilex - player->tilex);
        dy = abs(ob->tiley - player->tiley);
        dist = dx>dy ? dx:dy;

        if (ob->obclass == sniperobj)
            dist = 1;                                   // snipers are better shots

        if (thrustspeed >= RUNSPEED)
        {
            if (ob->flags&FL_VISABLE)
                hitchance = 160-dist*16;                // player can see to dodge
            else
                hitchance = 160-dist*8;
        }
        else
        {
            if (ob->flags&FL_VISABLE)
                hitchance = 256-dist*16;                // player can see to dodge
            else
                hitchance = 256-dist*8;
        }

        // see if the shot was a hit

        if (US_RndT()<hitchance)
        {
            if (dist<2)
                damage = US_RndT()>>2;
            else if (dist<4)
                damage = US_RndT()>>3;
            else
                damage = US_RndT()>>4;

            FireBullet(ob,0,dam_none,0,1,0);
            TakeDamage(damage,ob,dam_bullet,false,true);
            return true;
        }
    }

    return false;
}


/*
===============
=
= T_Shoot
=
= Try to damage the player, based on skill level and player's speed
=
= WSJ: now uses AlumiuN's bullet tracing
=
===============
*/

void T_Shoot (objtype *ob)
{
    switch(ob->obclass)
    {
        case officerobj:
            FireBullet(ob,(4 + US_RndT()%12),dam_bullet,1,1,(SPR_HTRACER_1-SPR_TRACER_1));
            break;
        case riflemanobj:
            FireBullet(ob,(10 + US_RndT()%10),dam_bullet,1,1,0);
            break;
        case ssriflemanobj:
            FireBullet(ob,(10 + US_RndT()%10),dam_bullet,0,1,0);
            break;
        case infantryobj:
        case officer2obj:
            FireBullet(ob,(3 + US_RndT()%10),dam_bullet,3,1,0);
            break;
        case mutantobj:
            FireBullet(ob,(2 + US_RndT()%10),dam_bullet,3,1,0);
            break;
        case ssobj:
        case ssofficerobj:
        case ssofficer2obj:
            FireBullet(ob,(3 + US_RndT()%10),dam_bullet,2,1,0);
            break;
        case waffenssobj:
        case waffenofficerobj:
            FireBullet(ob,(7 + US_RndT()%10),dam_bullet,1,1,0);
            break;
        case sniperobj:
            if (!InstantShot(ob))    // WSJ: if missed, draw bullet effects
                FireBullet(ob,(15 + US_RndT()%10),dam_bullet,0,1,0);
            break;
        case mg42guardobj:
        case mg42ssobj:
        case mg42waffenssobj:
        case mechtrooperobj:
            FireBullet(ob,(2 + US_RndT()%10),dam_machinegun,3,1,0);
            break;
        case bossobj:
        case panzobj:
            FireBullet(ob,(2 + US_RndT()%10),dam_chaingun,4,2,0);
            break;
        case deatharmorobj:
            ProjOffsFire(ob,sparkobj,&s_etracer1,0x8000l,(SPR_ETRACER_1-SPR_TRACER_1),1);
            ProjOffsFire(ob,sparkobj,&s_etracer1,0x8000l,(SPR_ETRACER_1-SPR_TRACER_1),2);
            break;
        case schabbobj:
            FireBullet(ob,(3 + US_RndT()%10),dam_mutagen,1,1,(SPR_MTRACER_1-SPR_TRACER_1));
            break;
        case flametrooperobj:
            ProjFire(ob,fireobj,&s_fire1,0x3000l,0);
            break;
        case chaingunnerobj:
        case fatobj:
            FireBullet(ob,(3 + US_RndT()%10),dam_chaingun,4,1,0);
            break;
        default:
            FireBullet(ob,(4 + US_RndT()%12),dam_bullet,2,1,(SPR_HTRACER_1-SPR_TRACER_1));
    }
}


/*
===============
=
= T_Bite
=
===============
*/

void T_Bite (objtype *ob)
{
    int32_t    dx,dy;

    int sounds[3]={DOGATTACK1SND,DOGATTACK2SND};
    PlayActorVoice(sounds[Random(2)],chan_voice_dog,ob);
    ob->ambientcount = 0;

    dx = player->x - ob->x;
    if (dx<0)
        dx = -dx;
    dx -= TILEGLOBAL;
    if (dx <= MINACTORDIST)
    {
        dy = player->y - ob->y;
        if (dy<0)
            dy = -dy;
        dy -= TILEGLOBAL;
        if (dy <= MINACTORDIST)
        {
            TakeDamage ((10+Random(30)),ob,dam_melee,false,true);
            return;
        }
    }
}


/*
===============
=
= ProjFire
=
= WSJ: projectile attack
=
===============
*/

void ProjOffsFire (objtype *ob, classtype type, statetype *state, int32_t speed, short spriteoffset, short angleoffs)
{
    int iangle;

    GetNewActor ();
    newobj->state = state;
    newobj->ticcount = 1;

    newobj->tilex = ob->tilex;
    newobj->tiley = ob->tiley;
    newobj->x = ob->x;
    newobj->y = ob->y;
    newobj->dir = nodir;

    iangle = ob->angle;
    if (angleoffs == 1)
    {
        iangle-=4;
        if (iangle<0)
            iangle+=ANGLES;
    }
    else if (angleoffs == 2)
    {
        iangle+=4;
        if (iangle>=ANGLES)
            iangle-=ANGLES;
    }

    newobj->angle = iangle;
    newobj->obclass = type;
    newobj->speed = speed;
    newobj->flags = FL_NEVERMARK;
    newobj->active = ac_yes;
    newobj->sproffset = spriteoffset;
}

void ProjFire (objtype *ob, classtype type, statetype *state, int32_t speed, short spriteoffset)
{
    ProjOffsFire (ob,type,state,speed,spriteoffset,0);
}

